
/*******************************************************************
 $CRT 30 Jan 1997 : hb

 $AUT Holger Burkarth
 $DAT >>UniqueFileID.c<<   30 Jan 1997    13:35:13 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/ex/UniqueFileID p:pLib/StartCode.o p:/pOS_RKRM/pDos/UniqueFileID.c p:pLib/StdIO.o -l pOSStub -l pOS

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

/*\
*** Example:
***
\*/


#define __COMPUTER_AMIGA 1
#define NOMYDEBUG

#include "p:pExec/Types.h"
#include "p:pDOS/ArgTags.h"
#include "p:pDOS/DosSig.h"
#include "p:pDOS/DosErrors.h"
#include "p:pDOS/Process.h"
#include "p:pDos/Lock.h"
#include "p:pDOS/DosDev.h"
#include "p:proto/pLibExt.h"
#include "p:proto/pExec2.h"
#include "p:proto/pDOS2.h"

#ifdef _____ME_____
  #include "grund/inc_string.h"
  #include "grund/inc_stdio.h"
#else
 #ifdef __cplusplus
 extern "C" {
 #endif
  #include <string.h>
  #include <stdio.h>
 #ifdef __cplusplus
 }
 #endif
#endif


const CHAR *HelpText=
""
;

const CHAR *PrgHeader=
"";

const CHAR *PrgVerText=
"$VER: 1.0 ("__DATE2__") (Copyright 1997 by proDAD) (Created by Holger Burkarth)";



/*----------------------------------
-----------------------------------*/
#ifdef __cplusplus
extern "C"
#endif

VOID main()
{
  struct pOS_DosArgs* Args;
  ULONG Ops[1]={0};

  Args=pOS_ReadDosArgs(
// 0
"NAME/A",
Ops,sizeof(Ops)/sizeof(ULONG),

    ARGTAG_PrgHeaderText, (ULONG)PrgHeader,    /* kurze Programm-Beschreibung */
    ARGTAG_HelpText,      (ULONG)HelpText,     /* Help-Texte */
    ARGTAG_PrgVerText,    (ULONG)PrgVerText,   /* VER-String */
    TAG_END);

  if(Args) {
    pOS_FileLock* Lock;

    if(Lock=pOS_LockObject(NULL,(dosname_t*)Ops[0],FILELKACC_Shared)) {
      pOS_DosIOReq   IOReq;

      pOS_InitDosIOReq(Lock->fl_DosDev,&IOReq);
      IOReq.dr_Command = DOSCMD_GetUniqueID;
      IOReq.dr_U.dr_GetUniqueID.drgq_Lock=Lock;
      IOReq.dr_U.dr_GetUniqueID.drgq_FH=NULL;
      pOS_DoIO((pOS_IORequest*)&IOReq);
      if(IOReq.dr_Error2==0) {
        printf("Name=<%s>, Dev=<%s>, UniqueFileID=0x%lx \n",
          Ops[0],Lock->fl_DosDev->ddv_Dev.lib_Node.ln_Name,
          IOReq.dr_U.dr_GetUniqueID.drgq_Result);
      }
      else pOS_PrintDosErr(NULL,(CHAR*)Ops[0],IOReq.dr_Error2);

      pOS_UnlockObject(Lock);
    }
    else pOS_PrintDosErr(NULL,(CHAR*)Ops[0],0);

    pOS_DeleteDosArgs(Args);
  }
}


