
/*******************************************************************
$CRT 15 Jan 1997 : hp

$AUT Holger Papajewski
$DAT >>Dtilbm.c<<   27 Jan 1997    14:27:09 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/Libs/ilbmdt.library p:pLib/LibCode.o p:/pOS_RKRM/pDtType/Dtilbm.c -l pOSStub -l pOS -l CPPList

// StormC:StormSys/StormC -g20 -gD -gC -O9 -pp -i p: -i ci: -wEPRTcV p:/pOS_RKRM/pDtType/Dtilbm.c
// StormC:StormSys/StormLink p:pLib/LibCode.o p:/pOS_RKRM/pDtType/Dtilbm.o To pos:pos/Libs/ilbmdt.library LIBPATH ram:lib LIB pOSStub pOS CPPList debug.lib amiga LOG ram:lib/logfile OOP

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

#define NOMYDEBUG


#include <p:pExec/Library.h>
#include <p:pExec/Diagnos.h>
#include <p:pExec/TstTags.h>
#include <p:pDOS/ArgTags.h>
#include <p:pDOS/DosSig.h>
#include <p:pDOS/DosErrors.h>
#include <p:pDOS/Segment.h>
#include <p:pDOS/Files.h>
#include "p:pDOS/IOStruct.h"
#include <p:pIFFParse/IFFParse.h>
#include <p:pIFFParse/IFFParseTags.h>
#include <p:pDtType/DtBase.h>
#include <p:pDtType/DtTags.h>
#include <p:pDtType/DClass.h>
#include <p:pDtType/Picture.h>
#include <p:pGFX/StdGMap.h>
#include <p:pGFX/GfxMap.h>
#include <p:pGFX/Color.h>
#include <p:pGFX/GfxTags.h>

#include <p:proto/pLibExt.h>
#include <p:proto/pExec2.h>
#include <p:proto/pDOS2.h>
#include <p:proto/pList.h>
#include <p:proto/pGFX2.h>
#include <p:proto/pIFFParse2.h>
#include <p:proto/pUtil2.h>


#ifdef __cplusplus
extern "C" {
#endif
  #include <string.h>
  #include <limits.h>
#ifdef __cplusplus
}
#endif



#ifdef __cplusplus
extern "C"
{
  void InitModules();
  void CleanupModules();
}
#endif



#define	MIN(a,b)     ( (a)<(b)?(a):(b) )

#define ID_ILBM MAKE_ID('I','L','B','M')
#define ID_BMHD MAKE_ID('B','M','H','D')
#define ID_CMAP MAKE_ID('C','M','A','P')
#define ID_CAMG MAKE_ID('C','A','M','G')
#define ID_BODY MAKE_ID('B','O','D','Y')

/* spezielle AmigaModes - sind in der ModeID im CAMG-Chunk*/
enum AmigaSpecialColorModes
{
  HAM_KEY = 0x00000800,
  EHB_KEY = 0x00000080,
};

/* ColorMode des geladenen Bildes */
enum SpecialColorMode
{
  COLMD_Normal = 0,
  COLMD_EHB,
  COLMD_HAM6,
  COLMD_HAM8,
};

/* BitMapHeader-Struktur des BMHD-Chunk */
struct ILBM_BMHD
{
  UWORD   bmh_Width;
  UWORD   bmh_Height;
  WORD    bmh_Left;
  WORD    bmh_Top;
  UBYTE   bmh_Depth;
  UBYTE   bmh_Masking;
  UBYTE   bmh_Compression;
  UBYTE   bmh_Pad;
  UWORD   bmh_Transparent;
  UBYTE   bmh_XAspect;
  UBYTE   bmh_YAspect;
  WORD    bmh_PageWidth;
  WORD    bmh_PageHeight;
};

/* auf 24 BitPlanes erweiterte pOS_StdPlanarGfxMap */
struct StdPlanar24GfxMap
{
  pOS_GfxMap  pl24gm_Gfx;
  UWORD       pl24gm_BytesPerRow;
  UBYTE       pl24gm_Depth;
  UBYTE       pl24gm_Pad;
  UBYTE      *pl24gm_Planes[24];
};


/* unsere Library-Struktur mit unserer NClass */
struct pOSp_DtLib
{
  pOS_Library  dl_Lib;

  pOS_NClass  *dl_DtClass;
};


/* die privaten Daten des ILBM-DTs */
struct pOSp_DtData
{
  dospos_t        dtd_BodyPos;

  ILBM_BMHD       dtd_Bmh;
  UWORD           dtd_ColMode;
  ULONG           dtd_BodySize;
  ULONG           dtd_ColMapSize;
  UBYTE          *dtd_Body;
  UBYTE          *dtd_ColR;
  UBYTE          *dtd_ColG;
  UBYTE          *dtd_ColB;
};



struct pOS_ExecBase* gb_ExecBase;
struct pOS_ExecLibFunction* gb_ExecLib;
struct pOS_DosBase      *gb_DosBase;
struct pOS_UtilityBase  *gb_UtilityBase;
struct pOS_GfxBase      *gb_GfxBase;
struct pOS_IFFParseBase *gb_IFFParseBase;
struct pOS_IntuiDevice  *gb_IntuiBase;

extern ULONG *FuncTable[];
const CHAR LibraryName[]  ="ilbmdt.library";
const CHAR LibraryIDName[]="ilbmdt.library 1.0 ("__DATE2__") (Copyright proDAD, Created by Holger Papajewski)";


const pOS_TagItem LibraryDescribe[]=
{
  EXTSTTAG_MainOSID, pOS_MAINOSID,
  TAG_END
};


BOOL pLibMain(_R_LB pOS_ExecBase*,_R_A0 pOSp_DtLib*);
ULONG DtDispatcher(_R_LB pOS_ExecBase*,_R_A0 const pOS_Class*,_R_A1 pOSp_DtData*,_R_A2 pOS_DtTypeMethod*);
VOID DtDispose(pOSp_DtData* obj);


pOS_ResidentLibInit InitTable=
{
  sizeof(pOSp_DtLib),
  FuncTable,
  NULL,
  (BOOL(*)(_R_LB pOS_ExecBase*,_R_A0 pOS_Library*))pLibMain
};


/*----------------------------------
 Wird in dieser Library nicht bentigt.
-----------------------------------*/
BOOL Open_func(_R_LB pOSp_DtLib*)      { return(1); }
VOID Close_func(_R_LB pOSp_DtLib*)     {}
ULONG Reserved_func(_R_LB pOSp_DtLib*) { return(0); }



/*----------------------------------
-----------------------------------*/
pOS_SegmentLst* Expunge_func(_R_LB pOSp_DtLib* lib)
{
  lib->dl_Lib.lib_Flags |= LIBF_DELEXP;     /* verzgertes Schlieen aktivieren */
  if(lib->dl_Lib.lib_OpenCnt==0) {          /* alle Verwender aben pOS_CloseLibrary() aufgerufen */
    pOS_SegmentLst* Seg=lib->dl_Lib.lib_Segm;

    pOS_ListRemove(&lib->dl_Lib.lib_Node);

    if(lib->dl_DtClass) pOS_DeleteClass(lib->dl_DtClass);

    _pOS_FreeLibraryMem2(&lib->dl_Lib); /* Lib-Memory freigeben */

    pOS_CloseLibrary((pOS_Library*)gb_IFFParseBase);
    pOS_CloseLibrary((pOS_Library*)gb_IntuiBase);
    pOS_CloseLibrary((pOS_Library*)gb_GfxBase);
    pOS_CloseLibrary((pOS_Library*)gb_DosBase);
    pOS_CloseLibrary((pOS_Library*)gb_UtilityBase);
#ifdef __cplusplus
    CleanupModules();
#endif
    return(Seg);
  }
  return(0);
}


ULONG *FuncTable[]=
{
 (ULONG*)Open_func,
 (ULONG*)Close_func,
 (ULONG*)Expunge_func,
// ------------
 (ULONG*)Reserved_func,
 (ULONG*)Reserved_func,
 (ULONG*)Reserved_func,
 (ULONG*)Reserved_func,
 (ULONG*)Reserved_func,
 (ULONG*)Reserved_func,
 (ULONG*)Reserved_func,
 (ULONG*)Reserved_func,
// ------------

 (ULONG*)ULONG_MAX
};



/*----------------------------------
-----------------------------------*/
BOOL pLibMain(_R_LB pOS_ExecBase* exec,_R_A0 pOSp_DtLib* lib)
{
#ifdef __pOS_EXECPRECODE
  extern struct pOS_ExecBase* gb_ExecBase;
  extern struct pOS_ExecLibFunction* gb_ExecLib;

  gb_ExecBase=(struct pOS_ExecBase*)exec;
  gb_ExecLib=*((struct pOS_ExecLibFunction**)lib->dl_Lib.lib_Segm->sel_Seg.seg_Reserved2);

  gb_DosBase    =(pOS_DosBase*)pOS_OpenLibrary("pdos.library",0);
  gb_UtilityBase=(pOS_UtilityBase*)pOS_OpenLibrary("putility.library",0);
  gb_GfxBase    =(pOS_GfxBase*)pOS_OpenLibrary("pgraphics.library",0);
  gb_IntuiBase  =(pOS_IntuiDevice*)pOS_OpenLibrary("pintui.library",0);
#else
 #error hier fehlt etwas
#endif

#ifdef __cplusplus
  InitModules();
#endif

  BOOL res=FALSE;

  gb_IFFParseBase=(pOS_IFFParseBase*)pOS_OpenLibrary("piffparse.library",0);

  lib->dl_DtClass =
     pOS_CreateClass("DtType/ilbm.class",pOS_DTNAME_PICTURE,NULL,
                       (APTR)DtDispatcher,sizeof(pOSp_DtData),0);

  if(lib->dl_DtClass==NULL || gb_IFFParseBase==NULL) {
    if( lib->dl_DtClass ) pOS_DeleteClass(lib->dl_DtClass);
    if( gb_IFFParseBase ) pOS_CloseLibrary((pOS_Library*)gb_IFFParseBase);

    pOS_CloseLibrary((pOS_Library*)gb_IntuiBase);
    pOS_CloseLibrary((pOS_Library*)gb_GfxBase);
    pOS_CloseLibrary((pOS_Library*)gb_DosBase);
    pOS_CloseLibrary((pOS_Library*)gb_UtilityBase);
#ifdef __cplusplus
    CleanupModules();
#endif
  }
  else res=TRUE;

  return(res);
}



/*******************************************************************************/


/*----------------------------------
Speichert Daten aus dem BitMapHeader in pOS_DtTypePicture
-----------------------------------*/
VOID GetInfoData( pOS_DtTypePicture *data, ILBM_BMHD *bmh )
{
  strcpy(data->dtpic_ID,"ILBM");
  data->dtpic_Width          = bmh->bmh_Width;
  data->dtpic_Height         = bmh->bmh_Height;
  data->dtpic_PageWidth      = bmh->bmh_PageWidth;
  data->dtpic_PageHeight     = bmh->bmh_PageHeight;
  data->dtpic_XAspect        = bmh->bmh_XAspect ? bmh->bmh_XAspect : 1;
  data->dtpic_YAspect        = bmh->bmh_YAspect ? bmh->bmh_YAspect : 1;
  data->dtpic_Colors         = 1L << bmh->bmh_Depth;
  data->dtpic_Masking        = bmh->bmh_Masking;
  data->dtpic_Compression    = bmh->bmh_Compression;
  data->dtpic_Transparent    = bmh->bmh_Transparent;
  data->dtpic_Frames         = 1;
  data->dtpic_Flags          = 0;
  data->dtpic_MicrosPerFrame = ~0;
  data->dtpic_GfxMapType     = GFXMAPTYP_StdRGB8;
  data->dtpic_ColorMapType   = COLMAPTYP_None;
  data->dtpic_GfxMapMaskType = GFXMAPTYP_None;
}

/*----------------------------------
Untersucht, ob es sich bei der Datei um ein IFF ILBM handelt
-----------------------------------*/
ULONG DtObtainFile(pOSp_DtData *obj,const pOS_DClassInfo* dci,
  const pOS_TagItem *tags, pOS_DtTypePicture *data)
{
  ULONG Res=DCLMTHR_None;
        pOS_IOStruct      *io = dci->dci_U.dci_IO;
        pOS_IFFHandle     *iff;
  const pOS_IFFStoredProp *sp;

/*\
*** IFFHandle im ReadMode ffnen
*** der uerste Chunk mu vom Type ILBM sein
\*/
  if( iff = pOS_OpenIFF( IFFTAG_IOStruct, (ULONG)io,
    IFFTAG_AccessMode, IFFACCMD_Read,
    IFFTAG_MainType, ID_ILBM, TAG_DONE)) {

/*\
*** wir bentigen Informationen aus dem BMGH und CAMG Chunk
\*/
    if( !pOS_PropChunk(iff,IFFTAG_ParseType,ID_ILBM,
      IFFTAG_ParseID,ID_BMHD,IFFTAG_ParseID,ID_CAMG,TAG_DONE)) {

/*\
*** es soll bis zum Ende des FORM Chunks gesucht werden
\*/
      if( !pOS_StopChunk(iff,IFFTAG_StopOnExit,TRUE,
        IFFTAG_StopType,ID_ILBM,IFFTAG_StopID,ID_FORM,TAG_DONE)) {

        pOS_ParseIFF(iff,IFFPARSE_Scan);

/*\
*** Zeiger auf geladenen BMHD chunk besorgen und
*** pOS_DtTypePicture fllen
*** wenn ein CAMG Chunk gefunden wurde - Anzahl der Farben
*** korrigieren (HAM)
\*/
        if( sp = pOS_FindProp(iff,ID_ILBM,ID_BMHD)) {
          if(data) {
            ILBM_BMHD *bmh = (ILBM_BMHD*)sp->sp_Data;

            GetInfoData( data, bmh );

            if( sp = pOS_FindProp(iff,ID_ILBM,ID_CAMG)) {
              if((*((ULONG*)sp->sp_Data)) & HAM_KEY ) {
                if( bmh->bmh_Depth == 6 )
                  data->dtpic_Colors = 4096;
                else if( bmh->bmh_Depth == 8 )
                  data->dtpic_Colors = 262144;
              }
            }
          }
/*\
***  der BMHD wurde gefunden - es ist auf jeden Fall ein IFF ILBM
\*/
          Res = DCLMTHR_Match;
        }
      }
    }
    pOS_CloseIFF( iff );
  }

  return( Res );
}



/*----------------------------------
ColorMap laden und jeweils ein Array fr R, G und B anlegen
wenn EHB, so wird die Palette mit den EHB_Farben erweitert
-----------------------------------*/
BOOL LoadColorMap( pOSp_DtData *obj, pOS_IFFHandle *iff )
{
  BOOL  Res = FALSE;
  ULONG MapSize;
  const pOS_IFFStoredProp *sp;

  if( sp = pOS_FindProp( iff, ID_ILBM, ID_CMAP )) {

    if( obj->dtd_ColMode == COLMD_EHB )
      MapSize = sp->sp_Size * 2;
    else
      MapSize = sp->sp_Size;

    if(obj->dtd_ColR=(UBYTE*)pOS_AllocMem(MapSize,MEMF_VMEM)) {

      UWORD  Num = MapSize / 3;
      UBYTE *Pal = sp->sp_Data;
      UBYTE *R = obj->dtd_ColR;
      UBYTE *G = R + Num;
      UBYTE *B = G + Num;
      UWORD  cnt;

      obj->dtd_ColG = G;
      obj->dtd_ColB = B;
      obj->dtd_ColMapSize = MapSize;

      if( obj->dtd_ColMode == COLMD_EHB ) {
        Num >>= 1;
        UBYTE *EHBr = R + Num;
        UBYTE *EHBg = G + Num;
        UBYTE *EHBb = B + Num;

        for( cnt=0; cnt < Num; cnt++ ) {
          *R      = *Pal++;
          *G      = *Pal++;
          *B      = *Pal++;
          *EHBr++ = *R++ >> 1;
          *EHBg++ = *G++ >> 1;
          *EHBb++ = *B++ >> 1;
        }

        obj->dtd_ColMode = COLMD_Normal;
      }
      else {
        for(cnt=0; cnt < Num; cnt++ ) {
          *R++ = *Pal++;
          *G++ = *Pal++;
          *B++ = *Pal++;
        }
      }

      Res = TRUE;
    }
  }

  return( Res );
}



/*----------------------------------
Laden der wichtigsten Bilddaten

Um nicht unntig viel Speicher zu verbrauchen, sollte der DT
nur die *wichtigsten* Daten einladen.
In unserem Fall ist dies die Palette und der BitMapHeader.
Um spter bei DCLMTH_Read den Body laden zu knnen, merken
wir uns die Position, an welcher der Body beginnt.
So knnen wir zu jeder Zeit den Body laden und das Bild generieren.
-----------------------------------*/
ULONG DtLoadFile(pOSp_DtData *obj,const pOS_DClassInfo* dci,
  const pOS_TagItem *tags, pOS_DtTypePicture *data)
{
  ULONG Res=DCLMTHR_None;
        pOS_IOStruct      *io = dci->dci_U.dci_IO;
        pOS_IFFHandle     *iff;
  const pOS_IFFStoredProp *sp;


/*\
*** IFFHandle ffnen
*** BMHD, CAMG & CMAP Chunks sollen gelesen werden
\*/
  if( iff = pOS_OpenIFF( IFFTAG_IOStruct, (ULONG)io,
    IFFTAG_AccessMode, IFFACCMD_Read,
    IFFTAG_MainType, ID_ILBM, TAG_DONE)) {

    if( !pOS_PropChunk(iff,IFFTAG_ParseType,ID_ILBM,
      IFFTAG_ParseID,ID_BMHD,IFFTAG_ParseID,ID_CAMG,
      IFFTAG_ParseID,ID_CMAP,TAG_DONE)) {

/*\
*** File nur bis Start des BODY Chunks lesen
\*/
      if( !pOS_StopChunk(iff,IFFTAG_StopType,ID_ILBM,
        IFFTAG_StopID,ID_BODY,TAG_DONE)) {

        pOS_ParseIFF(iff,IFFPARSE_Scan);

/*\
*** BitMapHeader ermittel und Daten in unseren privaten Teil
*** kopieren
\*/
        if( sp = pOS_FindProp(iff,ID_ILBM,ID_BMHD)) {
          pOS_CopyMem(sp->sp_Data,&obj->dtd_Bmh,sizeof(ILBM_BMHD));

/*\
*** CurrentChunk ermitteln
*** das MUSS der BODY sein - sonst ist ein Fehler aufgetreten
\*/
          const pOS_IFFLocContext *lc=pOS_CurrentChunk(iff);
          if( lc && lc->ifflc_ID == ID_BODY ) {

/*\
*** Position und Gre des Bodys merken
\*/
            obj->dtd_BodyPos  = _IOSTSEEK(io,0,FILEHDSEK_Current);
            obj->dtd_BodySize = lc->ifflc_Size;

/*\
*** ist Depth <= 8, so muss ein CMAP Chunk vorhanden sein
***   die Palette wird eingelesen und in unser spezielles Format
***   konvertiert
*** Ist die Depth > 8, dann MUSS sie 24 sein. Fr ein True Color
***   ILBM brauchen wir keine Palette, da die Farbinformation
***   in den 24 BitPlanes steht.
\*/
            if( obj->dtd_Bmh.bmh_Depth <= 8 ) {

              if( sp = pOS_FindProp(iff,ID_ILBM,ID_CAMG)) {
                ULONG modeID = *((ULONG*)sp->sp_Data);

                obj->dtd_ColMode = COLMD_Normal;
                if( modeID & EHB_KEY ) obj->dtd_ColMode = COLMD_EHB;
                else if( modeID & HAM_KEY ) {
                  if( obj->dtd_Bmh.bmh_Depth == 6 )
                    obj->dtd_ColMode = COLMD_HAM6;
                  else if( obj->dtd_Bmh.bmh_Depth == 8 )
                    obj->dtd_ColMode = COLMD_HAM8;
                }

                if( LoadColorMap(obj,iff)) Res = DCLMTHR_Ok;
              }
            }
            else if( obj->dtd_Bmh.bmh_Depth == 24 ) Res = DCLMTHR_Ok;
          }
        }
      }
    }
    pOS_CloseIFF( iff );
  }

  return( Res );
}


/*----------------------------------
Decodiert eine Zeile aus dem Body
Die Daten werden in einer pOS_StdPlanarGfxMap mit Hhe 1
abgelegt.
-----------------------------------*/
BOOL DecodeBodyLine( SBYTE **bodyPtr, ILBM_BMHD *bmh,
  pOS_StdPlanarGfxMap *map)
{
  BOOL   Res  = TRUE;
  SBYTE *body = *bodyPtr;
  UWORD  depth;
  UWORD  BytesPerRow = map->plgm_BytesPerRow;

  if( bmh->bmh_Compression == 0 ) {
    for( depth=0; depth < bmh->bmh_Depth; depth++ ) {
      pOS_CopyMem( body, map->plgm_Planes[depth], BytesPerRow );
      body += BytesPerRow;
    }
  }
  else if( bmh->bmh_Compression == 1 ) {
    SWORD  bpr;
    UBYTE *pp;
    SWORD  x;

    for( depth=0; depth < bmh->bmh_Depth && Res; depth++ ) {
      bpr = BytesPerRow;
      pp  = map->plgm_Planes[depth];

      while( bpr > 0 ) {
        if( *body>=0 && *body<=127 ) {
          x = *body++;
          bpr -= ++x;
          while( x-- ) *pp++ = *body++;
        }
        else if( *body>=-127 && *body<=-1 ) {
          x = -(*body++);
          bpr -= ++x;
          while( x-- ) *pp++ = *body;
          body++;
        }
        else if( *body==128 ) body++;
      }
      Res = (bpr == 0);
    }
  }
  else Res = FALSE;

  if( Res == TRUE )
    *bodyPtr = body;

  return( Res );
}


/*----------------------------------
Konvertiert eine Planar-Zeile in Chunky8
-----------------------------------*/
VOID PlanarRow2Chunky(UBYTE **planes,UBYTE *line,UWORD width,UBYTE depth)
{
  UBYTE *CurL, Cnt, ChunkyMask;
  UWORD  x, minW, W;
  ULONG *InPl, BitMask, Store;

  memset( line, 0, width );
  for( Cnt=0,ChunkyMask=1; Cnt<depth; Cnt++,ChunkyMask<<=1 ) {
    CurL = line;
    W    = width;
    InPl = (ULONG*)planes[Cnt];

    while( W ) {
      minW = MIN(32,W);
      Store = *InPl++;
      for( x=0,BitMask=0x80000000; x<minW; x++,CurL++,BitMask>>=1 )
        if( Store & BitMask) *CurL |= ChunkyMask;

      W -= minW;
    }
  }
}

/*----------------------------------
Konvertiert eine Chunky8-Zeile nach RGB unter Bercksichtigung
der speziellen AmigaModie
-----------------------------------*/
VOID ChunkyRow2RGB8( UBYTE *cline, UBYTE *r, UBYTE *g, UBYTE *b,
  UWORD width, UBYTE **colMaps,UWORD colMode )
{
  UBYTE *R = colMaps[0];
  UBYTE *G = colMaps[1];
  UBYTE *B = colMaps[2];
  UBYTE OldR = 0;
  UBYTE OldG = 0;
  UBYTE OldB = 0;
  UBYTE index;

  switch( colMode ) {
// -----
    case COLMD_Normal:
      while( width-- ) {
        *r++ = R[*cline];
        *g++ = G[*cline];
        *b++ = B[*cline];
        cline++;
      }
      break;
// -----
    case COLMD_HAM6:
      while( width-- ) {
        index = *cline++;
        switch( index & 0x30 ) {
// -----
          case 0x00: // alles neu
            *r++ = OldR = R[index];
            *g++ = OldG = G[index];
            *b++ = OldB = B[index];
            break;
// -----
          case 0x20: // rot ndern
            index <<= 4;
            *r++ = OldR = index;
            *g++ = OldG;
            *b++ = OldB;
            break;
// -----
          case 0x10: // blau ndern
            index <<= 4;
            *r++ = OldR;
            *g++ = OldG;
            *b++ = OldB = index;
            break;
// -----
          default: // muss 0x30 grn ndern
            index <<= 4;
            *r++ = OldR;
            *g++ = OldG = index;
            *b++ = OldB;
            break;
        }
      }
      break;
// -----
    case COLMD_HAM8:
      while( width-- ) {
        index = *cline++;
        switch( index & 0xC0 ) {
// -----
          case 0x00: // alles neu
            *r++ = OldR = R[index];
            *g++ = OldG = G[index];
            *b++ = OldB = B[index];
            break;
// -----
          case 0x80: // rot ndern
            index <<= 2;
            *r++ = OldR = index;
            *g++ = OldG;
            *b++ = OldB;
            break;
// -----
          case 0x40: // blau ndern
            index <<= 2;
            *r++ = OldR;
            *g++ = OldG;
            *b++ = OldB = index;
            break;
// -----
          default: // muss 0xC0 sein  grn ndern
            index <<= 2;
            *r++ = OldR;
            *g++ = OldG = index;
            *b++ = OldB;
            break;
        }
      }
      break;
// -----
    default:
      break;
  }
}


/*----------------------------------
Fllt pOS_StdRGB8GfxMap mit den BildDaten
Nur fr Bilder mit Depth <= 8
-----------------------------------*/
BOOL Planar2RGB8(pOSp_DtData *obj, pOS_StdPlanarGfxMap *pmap,
  pOS_StdRGB8GfxMap *rgbmap )
{
  BOOL Res = TRUE;
  UBYTE *ChunkyLine = (UBYTE*)pOS_AllocMem(obj->dtd_Bmh.bmh_Width,MEMF_VMEM);

  if( ChunkyLine ) {
    ILBM_BMHD *bmh = &obj->dtd_Bmh;
    UBYTE     *Body = obj->dtd_Body;
    UBYTE     *R = rgbmap->rgbgm_R;
    UBYTE     *G = rgbmap->rgbgm_G;
    UBYTE     *B = rgbmap->rgbgm_B;
    UWORD      zeile;
    UWORD      width = bmh->bmh_Width;

    for( zeile=0; zeile<bmh->bmh_Height && Res; zeile++ ) {

      if( DecodeBodyLine((SBYTE**)&Body, bmh, pmap )) {
        PlanarRow2Chunky(pmap->plgm_Planes,ChunkyLine,width,bmh->bmh_Depth);
        ChunkyRow2RGB8(ChunkyLine,R,G,B,width,(UBYTE**)&obj->dtd_ColR,obj->dtd_ColMode);

        R += width;
        G += width;
        B += width;
      }
      else Res = FALSE;
    }

    pOS_FreeMem( ChunkyLine, obj->dtd_Bmh.bmh_Width );
  }
  else Res = FALSE;

  return( Res );
}




/*----------------------------------
Gibt Speicher einer StdPlanar24GfxMap ans System zurck
-----------------------------------*/
VOID FreePlanar24GfxMap( StdPlanar24GfxMap *Map )
{
  UBYTE Cnt;
  ULONG PlaneSize = (((Map->pl24gm_Gfx.gm_Width+15)>>3)&0xfffe) * Map->pl24gm_Gfx.gm_Height;

  if( Map ) {

    for( Cnt=0; Cnt<24; Cnt++ )
      if( Map->pl24gm_Planes[Cnt] )
        pOS_FreeMem( Map->pl24gm_Planes[Cnt], PlaneSize );

    pOS_FreeMem(Map,sizeof(StdPlanar24GfxMap));
  }
}

/*----------------------------------
Da in pOS die maximale Depth einer PlanarGfxMap 8 ist,
mssen wir uns fr den TrueColor-Fall eine eigene Planar24GfxMap
erzeugen
Der Aufbau ist mit der pOS_StdPlanarGfxMap identisch. Es werden
nur 16 zustzliche Plane-Zeiger hinzugefgt.
-----------------------------------*/
StdPlanar24GfxMap* AllocPlanar24GfxMap( UWORD width, UWORD height )
{
  BOOL  Success = TRUE;
  UBYTE Cnt;
  ULONG PlaneSize;
  StdPlanar24GfxMap *Map;

  if( Map=(StdPlanar24GfxMap*)pOS_AllocMem(sizeof(StdPlanar24GfxMap),MEMF_CLEAR)) {

    Map->pl24gm_Gfx.gm_Width  = width;
    Map->pl24gm_Gfx.gm_Height = height;
    Map->pl24gm_Depth = 24;
    Map->pl24gm_BytesPerRow = PlaneSize = ((width+15)>>3)&0xfffe;
    PlaneSize *= height;

    for( Cnt=0; Cnt<24 && Success; Cnt++ ) {
      Map->pl24gm_Planes[Cnt]=(UBYTE*)pOS_AllocMem(PlaneSize,MEMF_VMEM);
      if( !Map->pl24gm_Planes[Cnt] )
        Success = FALSE;
    }

    if( !Success ) {
      FreePlanar24GfxMap( Map );
      Map = NULL;
    }
  }

  return( Map );
}




/*----------------------------------
Konvertiert ein TrueColor-ILBM nach RGB8
-----------------------------------*/
BOOL Planar24ToRGB8(pOSp_DtData *obj, StdPlanar24GfxMap *pmap,
  pOS_StdRGB8GfxMap *rgbmap )
{
  BOOL Res = TRUE;
  ILBM_BMHD *bmh = &obj->dtd_Bmh;
  UBYTE     *Body = obj->dtd_Body;
  UBYTE     *R = rgbmap->rgbgm_R;
  UBYTE     *G = rgbmap->rgbgm_G;
  UBYTE     *B = rgbmap->rgbgm_B;
  UWORD      width = rgbmap->rgbgm_Gfx.gm_Width;
  UWORD      zeile;

  for( zeile=0; zeile<bmh->bmh_Height && Res; zeile++ ) {

    Res = DecodeBodyLine((SBYTE**)&Body, bmh, (pOS_StdPlanarGfxMap*)pmap );
    if( Res ) {
      PlanarRow2Chunky(&pmap->pl24gm_Planes[0] ,R,width,8);
      PlanarRow2Chunky(&pmap->pl24gm_Planes[8] ,G,width,8);
      PlanarRow2Chunky(&pmap->pl24gm_Planes[16],B,width,8);

      R += width;
      G += width;
      B += width;
    }
  }

  return( Res );
}





/*----------------------------------
Fllt die bergebene pOS_StdRGB8GfxMap mit den Body-Daten
-----------------------------------*/
ULONG DtReadRGB8( pOSp_DtData *obj, const pOS_DClassInfo *dci,
  pOS_DtTypePicFrame *fra )
{
  ULONG Res = DCLMTHR_None;

  if( obj->dtd_Bmh.bmh_Depth <= 8 ) {
    pOS_StdPlanarGfxMap *PMap = (pOS_StdPlanarGfxMap*)pOS_AllocGfxMap( NULL,
      GFXTAG_Width,       obj->dtd_Bmh.bmh_Width,
      GFXTAG_Height,      1,
      GFXTAG_Depth,       obj->dtd_Bmh.bmh_Depth,
      GFXTAG_GfxType,     GFXMAPTYP_StdPlanar, TAG_DONE );

    if( PMap ) {
      if(Planar2RGB8(obj,PMap,(pOS_StdRGB8GfxMap*)fra->dtpicf_GfxMap))
        Res = DCLMTHR_Ok;

      pOS_FreeGfxMap((pOS_GfxMap*)PMap );
    }
  }
  else if( obj->dtd_Bmh.bmh_Depth == 24 ) {
    StdPlanar24GfxMap *PMap=NULL;

    if( PMap = AllocPlanar24GfxMap( obj->dtd_Bmh.bmh_Width, 1 )) {
      if( Planar24ToRGB8(obj,PMap,(pOS_StdRGB8GfxMap*)fra->dtpicf_GfxMap))
        Res = DCLMTHR_Ok;

      FreePlanar24GfxMap( PMap );
    }
  }

  return( Res );
}





/*----------------------------------
Springt an die Body-Position und liest den kompletten Body
-----------------------------------*/
BOOL GetBody( pOSp_DtData *obj, pOS_IOStruct *io )
{
  BOOL   Res  = FALSE;
  ULONG  Size = obj->dtd_BodySize;

  _IOSTSEEK( io, obj->dtd_BodyPos, FILEHDSEK_Begin );
  if( !pOS_GetIoErr()) {

    obj->dtd_Body = (UBYTE*)pOS_AllocMem( Size, MEMF_VMEM );
    if( obj->dtd_Body ) {
      Res = (_IOSTREAD( io, obj->dtd_Body, Size ) == Size);

      if( !Res ) {
        pOS_FreeMem( obj->dtd_Body, Size );
        obj->dtd_Body = NULL;
      }
    }
  }

  return( Res );
}





/*----------------------------------
BildDaten in die GfxMap lesen

Dabei ist auf den Type der bergebenen GfxMap zu achten.
Kann der empfangene GfxMapType nicht gefllt werden, so ist
DCLMTHR_Warn zurckzugeben. Die SuperKlasse hat dann die Chance,
uns einen anderen Type zur Verfgung zu stellen und diesen dann
zu konvertieren.

ACHTUNG - Zum derzeitigen Entwicklungsstand MUSS IMMER RGB8
          gefllt werden knnen.

Auerdem ist auf die ViewBox zu achten. Damit wird der Applikation
die Mglichkeit gegeben einzelne Bildausschnitte zu empfangen.
Sollte der DT dies nicht direkt untersttzen, muss sich die
SuperKlasse darum kmmern.
-----------------------------------*/
ULONG DtRead(pOSp_DtData* obj,const pOS_DClassInfo* dci,
  const pOS_TagItem *tags,pOS_DtTypePicFrame* fra)
{
  ULONG Res = DCLMTHR_None;

  pOS_GfxMap *const GfxMap = fra->dtpicf_GfxMap;
  pOS_IBox   *ClipBox = fra->dtpicf_ClipBox;

  if( fra->dtpicf_FrameNum == 1 &&
      GfxMap->gm_Width == obj->dtd_Bmh.bmh_Width &&
      GfxMap->gm_Height == obj->dtd_Bmh.bmh_Height &&
      ( !ClipBox ||
       (ClipBox->Left == 0 && ClipBox->Top == 0 &&
        ClipBox->Width == obj->dtd_Bmh.bmh_Width &&
        ClipBox->Height == obj->dtd_Bmh.bmh_Height ))) {

    if( fra->dtpicf_DrawBox ) {
      fra->dtpicf_DrawBox->Left   = 0;
      fra->dtpicf_DrawBox->Top    = 0;
      fra->dtpicf_DrawBox->Width  = obj->dtd_Bmh.bmh_Width;
      fra->dtpicf_DrawBox->Height = obj->dtd_Bmh.bmh_Height;
    }

    if( GetBody( obj, dci->dci_U.dci_IO )) {

      switch( GfxMap->gm_Type ) {
// -----
        case GFXMAPTYP_StdRGB8:
          Res = DtReadRGB8( obj, dci, fra );
          break;
// -----
        case GFXMAPTYP_StdPlanar:
        case GFXMAPTYP_StdChunky8:
        default:
          Res = DCLMTHR_Warn;
          break;
      }

      pOS_FreeMem( obj->dtd_Body, obj->dtd_BodySize );
      obj->dtd_Body = NULL;
    }
  }

  return( Res );
}





/*----------------------------------
Freigeben aller Resourcen
-----------------------------------*/
VOID DtDispose( pOSp_DtData *obj )
{
  if( obj->dtd_Body ) pOS_FreeMem( obj->dtd_Body, obj->dtd_BodySize );
  if( obj->dtd_ColR ) pOS_FreeMem( obj->dtd_ColR, obj->dtd_ColMapSize );
  memset(obj, 0, sizeof(pOSp_DtData));
}






/*----------------------------------
DTs mssen sich sehr schnell klonen lassen.
Es werden alle bentigten Daten aus dem Orginal in das neue
Objekt bernommen.
-----------------------------------*/
ULONG DtMakeClone( pOSp_DtData *clone, pOSp_DtData *old )
{
  ULONG Res = 1;

  pOS_CopyMem(&old->dtd_Bmh,&clone->dtd_Bmh,sizeof(ILBM_BMHD));
  clone->dtd_BodyPos    = old->dtd_BodyPos;
  clone->dtd_ColMode    = old->dtd_ColMode;
  clone->dtd_BodySize   = old->dtd_BodySize;
  clone->dtd_ColMapSize = old->dtd_ColMapSize;

  if( clone->dtd_ColMapSize ) {
    if( clone->dtd_ColR = (UBYTE*)pOS_AllocMem(clone->dtd_ColMapSize,MEMF_VMEM)) {
      pOS_CopyMem(old->dtd_ColR,clone->dtd_ColR,clone->dtd_ColMapSize);
      clone->dtd_ColG = clone->dtd_ColR + (clone->dtd_ColMapSize/3);
      clone->dtd_ColB = clone->dtd_ColG + (clone->dtd_ColMapSize/3);
    }
    else Res = pOS_CLASSERR;
  }

  return( Res );
}




/*----------------------------------
Der DataTypeDispatcher

Es ist immer die X-Methode zu verwenden, um Rekursionen
zu vermeiden.
-----------------------------------*/
ULONG DtDispatcher(_R_LB pOS_ExecBase* exec,_R_A0 const pOS_Class* cl,
                   _R_A1 pOSp_DtData *obj,_R_A2 pOS_DtTypeMethod* mth)
{
  const pOS_DClassInfo* DC=mth->dtth_U.dtth_Obtain.dtob_Info;;
  ULONG Res=0;

  switch(mth->dtth_Method) {
/*\
*** Da wir ausschlielich mit dem pOS_IOStruct arbeiten, geben wir
*** es mit dem Tag DCLTAG_NeedIOStruct der SuperKlasse bekannt.
*** Diese wird sich nun darum kmmern, da immer ein IOStruct vorhanden
*** ist.
\*/
    case DCLMTH_New:
      {
        pOS_TagItem tt[] = {DCLTAG_NeedIOStruct,TRUE,TAG_MORE,(ULONG)mth->dtth_U.dtth_New.dtnw_Tags};
        mth->dtth_U.dtth_New.dtnw_Tags = tt;

        Res=pOS_DoAbsMethodA(cl,obj,(pOS_Method*)mth);

        mth->dtth_U.dtth_New.dtnw_Tags = (pOS_TagItem*)tt[1].ti_Data;
      }
      break;



/*\
*** Datei berprfen, ob wir sie lesen knnen
*** Sollte uns das Dateiformat bekannt sein, ist DCLMTHR_Match
*** zurckzugeben
***
*** Sollte die DCLMTH_Load schon aufgerufen worden sein, so ist
*** (DCLMTHR_Match | DCLMTHR_Ok) zurckzugeben
\*/
    case DCLMTH_XObtain:
      switch(DC->dci_Flags & DCLINFOF_HandleMask) {
// -----
        case DCLINFOF_IO:
          if( DC->dci_Format==NULL ||
             stricmp(DC->dci_Format,pOS_DTFORM_PICTURE)==0) {

            Res = DtObtainFile(obj,DC,mth->dtth_U.dtth_Obtain.dtob_Tags,
              DC->dci_Format ? (pOS_DtTypePicture*)DC->dci_Data : NULL );
          }
          break;
// -----
        case DCLINFOF_None:
          if(obj->dtd_BodyPos && DC->dci_Data) {

            GetInfoData((pOS_DtTypePicture*)DC->dci_Data,&obj->dtd_Bmh);
            if( obj->dtd_ColMode == COLMD_HAM8 )
              ((pOS_DtTypePicture*)DC->dci_Data)->dtpic_Colors = 262144;
            else if( obj->dtd_ColMode == COLMD_HAM6 )
              ((pOS_DtTypePicture*)DC->dci_Data)->dtpic_Colors = 4096;

            Res = DCLMTHR_Ok | DCLMTHR_Match;
          }
          break;
// -----
        default:
          break;
      }
      break;



/*\
*** Die wichtigsten Daten des Bildes laden
\*/
    case DCLMTH_XLoad:
      switch(DC->dci_Flags & DCLINFOF_HandleMask) {
// -----
        case DCLINFOF_IO:
          if( stricmp(DC->dci_Format,pOS_DTFORM_PICTURE)==0) {

            Res = DtLoadFile(obj,DC,mth->dtth_U.dtth_Obtain.dtob_Tags,
              (pOS_DtTypePicture*)DC->dci_Data );
          }
          break;
// -----
        default:
          break;
      }
      break;



/*\
*** Bild lesen und in die bergebene GfxMap schreiben
\*/
    case DCLMTH_XRead:
      switch(DC->dci_Flags & DCLINFOF_HandleMask) {
// -----
        case DCLINFOF_IO:
          Res=DtRead(obj,DC,mth->dtth_U.dtth_Read.dtrd_Tags,
            (pOS_DtTypePicFrame*)mth->dtth_U.dtth_Read.dtrd_Data);
          break;
// -----
        default:
          break;
      }
      break;



/*\
*** Das DtObjekt soll eine Kopie von sich selbst herstellen.
*** Wir wurden soebend neu erzeugt und kopieren nun alle wichtigen
*** Daten aus dem Master-Objekt.
\*/
    case DCLMTH_XClone:
      Res=pOS_DoAbsMethodA(cl,obj,(pOS_Method*)mth);
      if( Res != pOS_CLASSERR ) {

        pOSp_DtData *master = (pOSp_DtData*)_DTTCLONEOFFSET(mth,obj);
        Res = DtMakeClone(obj,master);
      }
      break;




/*\
*** Es soll ein IObjekt erzeugt werden, welches in der Lage ist,
*** die Datei (in unserem Fall das Bild) anzuzeigen.
*** Wir berlassen das einfach der SuperKlasse. Sie wird fr Bilder
*** ein igfx-Objekt mit unserer GfxMap erzeugen.
\*/
//    case DCLMTH_XGetIObj:
//      break;





/*\
*** Das Objekt wird aus den Speicher entfernt. Wir haben alle
*** Resourcen wieder freizugeben.
\*/
    case DCLMTH_Dispose:
      DtDispose( obj );
      Res=pOS_DoAbsMethodA(cl,obj,(pOS_Method*)mth);
      break;



/*\
*** Alle uns unbekannten Methoden werden an die SuperKlasse
*** weitergeleitet.
\*/
    default:
      Res=pOS_DoAbsMethodA(cl,obj,(pOS_Method*)mth);
      break;
  }

  return( Res );
}

