
/*******************************************************************
 $CRT 23 Jan 1997 : hp

 $AUT Holger Papajewski
 $DAT >>GfxView.c<<   07 Feb 1997    11:24:58 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/Ex/GfxView p:pLib/StartCode.o p:/pOS_RKRM/pDtType/GfxView.c p:pLib/StdIO.o -l pOSStub -l pOS

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

/*\
*** Example:
***
\*/


#define __COMPUTER_AMIGA 1
#define NOMYDEBUG

#include <pExec/Types.h>
#include <pDOS/ArgTags.h>
#include <pDOS/DosSig.h>
#include <pDOS/DosErrors.h>
#include <pDOS/Lock.h>
#include <pGadget/Gadget.h>
#include <pGadget/PropGad.h>
#include <pGfx/StdGMap.h>
#include <pGfx/StdCMap.h>
#include <pGFX/GfxEx.h>
#include <pGfx/GfxTags.h>
#include <pGFX/RastPort.h>
#include <pGFX/Text.h>
#include <pScreen/ScrTags.h>
#include <pScreen/Window.h>
#include <pScreen/Screen.h>
#include <pIntui/IntuMsg.h>
#include <pIntui/WinFlags.h>
#include <pIntui/Tags.h>
#include <pIntui/GClass.h>
#include <pIntui/DragTags.h>
#include <pIntui/Beep.h>
#include <pDtType/DClass.h>
#include <pDtType/DtBase.h>
#include <pDtType/DtTags.h>
#include <pDtType/Picture.h>
#include <pDtType/DosObj.h>
#include <pSL/FileReq.h>
#include <pSL/pSLTags.h>
#include <proto/pLibExt.h>
#include <proto/pExec2.h>
#include <proto/pDOS2.h>
#include <proto/pIntui2.h>
#include <proto/pGFX2.h>
#include <proto/pDtType2.h>
#include <proto/pPSL2.h>


#ifdef _____ME_____

  #include "grund/inc_string.h"
  #include "grund/inc_stdio.h"

#else

  #define MIN(a,b) (((a)<(b))?(a):(b))
  #define MAX(a,b) (((a)>(b))?(a):(b))

  #ifdef ____PAPA____
    #include <debug.h>
    #ifdef __SASC
      #include <date.h>
    #endif
  #endif

  #ifdef __cplusplus
  extern "C" {
  #endif
    #include <string.h>
    #include <stdio.h>
  #ifdef __cplusplus
  }
  #endif

#endif


const CHAR *HelpText=
""
;

const CHAR *PrgHeader=
"";

const CHAR *PrgVerText=
#ifdef __SASC
  "$VER: 2.0 "__AMIGADATE__" (Copyright 1996-97 by proDAD) (Created by Holger Papajewski)";
#else
  "$VER: 2.0 ("__DATE2__") (Copyright 1996-97 by proDAD) (Created by Holger Papajewski)";
#endif



/*\
*** Struktur zum Buffern der Einzelbilder einer Animation
*** es wird die GfxMap, die ClipBox & die WarteZeit vermerkt
\*/
struct BufGfxMap
{
  struct pOS_GfxMap  *bgm_GfxMap;
  struct pOS_IBox     bgm_Box;
  ULONG               bgm_Delay;
};



/*\
*** Verwaltung aller wichtigen ProgrammDaten bzw. Strukturen
\*/
struct GVData
{
  struct pOS_PslFileRequester *gvd_FReq;

  struct pOS_DataType       *gvd_DType;
  struct pOS_DtTypePicture   gvd_Pic;
  struct pOS_DtTypePicFrame  gvd_Frame;
  struct pOS_DClassInfo      gvd_DCI;

  struct pOS_NClass         *gvd_Class;
  struct pOS_Gadget         *gvd_Gad;

  struct pOS_Window         *gvd_Win;
  struct pOS_IBox            gvd_WinBox;
  struct pOS_IBox            gvd_DrawBox;

  struct pOS_GfxMap         *gvd_GfxMap;
  struct BufGfxMap          *gvd_GfxArray;

  BOOL   gvd_AutoPlay;
  BOOL   gvd_Progressiv;
  BOOL   gvd_TryToBuffer;
  ULONG  gvd_Delay;
};



/*\
*** Dummy-Daten fr das abgeleitete Gadget
\*/
struct DragGadData
{
  ULONG  dummy;
};



/*\
*** private Prototypen
\*/
struct GVData *Setup( ULONG* );
VOID Cleanup( struct GVData* );

__ARID__ struct pOS_GfxMap *CreateGfxMap( struct pOS_DtTypePicture* );
VOID DeleteGfxMap( __ARID__ struct pOS_GfxMap* );
__ARID__ struct BufGfxMap *CreateGfxArray( struct GVData* );
VOID DeleteGfxArray( __ARID__ struct BufGfxMap*, ULONG );
VOID AddToGfxArray( struct BufGfxMap*,struct GVData* );

VOID ShowNextAnimFrame( struct GVData* );
VOID ShowNextProgressivFrame( struct GVData* );
VOID DrawGfxMap(struct pOS_Window*,struct pOS_IBox*,struct pOS_IBox*,struct pOS_GfxMap*);

BOOL HandleIDCMP( struct GVData* );
BOOL HandleKey( struct GVData*, CHAR );
VOID OpenNewFile( struct GVData* );
VOID ShowNewFile( struct GVData*,struct pOS_FileLock*,const CHAR*,struct pOS_DataType*);

VOID HandleDrop( struct GVData*, struct pOS_IEDragDrop* );


struct pOS_IntuiDevice  *gb_IntuiBase;
struct pOS_GfxBase      *gb_GfxBase;
struct pOS_DataTypeBase *gb_DtTypeBase;
struct pOS_pSLBase      *gb_PSLBase;


/*----------------------------------
-----------------------------------*/
#ifdef __cplusplus
extern "C"
#endif
VOID main()
{
  struct pOS_DosArgs* Args;
  UWORD        Err = 0;
  ULONG        Ops[6] = {0,1,0,0,0,0};

  gb_IntuiBase  =(struct pOS_IntuiDevice*)pOS_OpenLibrary("pintui.library",0);
  gb_GfxBase    =(struct pOS_GfxBase*)pOS_OpenLibrary("pgraphics.library",0);
  gb_DtTypeBase =(struct pOS_DataTypeBase*)pOS_OpenLibrary("pDtType.library",0);
  gb_PSLBase    =(struct pOS_pSLBase*)pOS_OpenLibrary("psl.library",0);

  Args=pOS_ReadDosArgs(
    /*  0         1           2             3              4          5 */
    "FILE/A, CL=CLOSE/S, BU=BUFFER/S, BL=BORDERLESS/S, L=LEFT/K/N, T=TOP/K/N",
    Ops,sizeof(Ops)/sizeof(ULONG),
    ARGTAG_PrgHeaderText,(ULONG)PrgHeader,  /* kurze Programm-Beschreibung */
    ARGTAG_HelpText,     (ULONG)HelpText,   /* Help-Texte */
    ARGTAG_PrgVerText,   (ULONG)PrgVerText, /* VER-String */
    TAG_END);

  if(Args) {
    struct GVData *Data = Setup( Ops );

    if( Data ) {
      BOOL  Run = TRUE;
      ULONG Sig;
      ULONG WinSig  = 1L << Data->gvd_Win->win_UserPort->mp_SigBit;
      ULONG SigMask = WinSig | DOSSIGF_CTRL_C;

      while( Run ) {

        if( Data->gvd_AutoPlay && Data->gvd_Delay == 0 )
          Data->gvd_Delay = Data->gvd_Pic.dtpic_MicrosPerFrame ?
                            Data->gvd_Pic.dtpic_MicrosPerFrame : 40000;

        Sig = pOS_WaitTimeSignal( SigMask, Data->gvd_Delay );

        if( Sig & DOSSIGF_CTRL_C )      Run = FALSE;
        else if( Sig & WinSig )         Run = HandleIDCMP( Data );
        else if( Data->gvd_Progressiv ) ShowNextProgressivFrame( Data );
        else if( Data->gvd_AutoPlay )   ShowNextAnimFrame( Data );

      }

      Cleanup( Data );
    }
    pOS_DeleteDosArgs(Args);  /* Args freigeben */
  }
  else Err=DOSFAIL_FAIL;  /* vollkommen fehlgeschlagen */

  pOS_SetShellFail(Err);
  pOS_CloseLibrary((struct pOS_Library*)gb_PSLBase);
  pOS_CloseLibrary((struct pOS_Library*)gb_IntuiBase);
  pOS_CloseLibrary((struct pOS_Library*)gb_GfxBase);
  pOS_CloseLibrary((struct pOS_Library*)gb_DtTypeBase);
}



/*----------------------------------
Um Drag&Drop zu ermglichen, befindet sich ein unsichtbares Gadget
im Fenster, welches den gesamten Innenraum des Fenster ausfllt.
Damit etwas aus den GfxView gedragt werden kann, mu dieses Gadget
ein DragObj erzeugen knnen. Wir leiten ein extra Gadget von der
GadgetBasisklasse "gadget.class" ab, welches nur die BeginDrag-
Methode ndert.
Die eigentlichen Aktionen zum Drag&Drop lassen sich von normalen
Messageloop ausfhren.
-----------------------------------*/
ULONG DragGadDisp(_R_LB struct pOS_ExecBase* exec,
  _R_A0 const struct pOS_Class* cl, _R_A1 struct DragGadData *obj,
  _R_A2 struct pOS_GadgetMethod* mth )
{
  ULONG ret=0;

  switch( mth->imth_Method ) {
// -----
    case GCLMTH_BeginDrag:
      {
        struct pOS_Gadget *Gad=(struct pOS_Gadget*)pOS_GetObjectRootAdr(cl,obj);
        const struct pOS_DrawInfo *Dri=mth->imth_U.imth_BDrag.imbd_Info->ici_DrawInfo;
        SWORD Dis = Dri->dri_Font->tf_YSize<<1;

        if(mth->imth_U.imth_BDrag.imbd_Offset) {
          mth->imth_U.imth_BDrag.imbd_Offset->X = Dis;
          mth->imth_U.imth_BDrag.imbd_Offset->Y = Dis+6;
        }

        mth->imth_U.imth_BDrag.imbd_Result = pOS_CreateDrag(
          DRAGTAG_LeftEdge,     mth->imth_U.imth_BDrag.imbd_AMouse->X - Dis,
          DRAGTAG_TopEdge,      mth->imth_U.imth_BDrag.imbd_AMouse->Y - Dis -6,
          DRAGTAG_GadDrag,      (ULONG)Gad->gad_Drag,
          DRAGTAG_DeleteRender, TRUE,
          DRAGTAG_Render,       (ULONG)pOS_NewIObject(
            NULL, "itext.class", 0,
            ICLTAG_DrawInfo,      (ULONG)Dri,
            IOBJTAG_StaticString, (ULONG)"GfxView\nPicture",
            TAG_DONE ),
          TAG_DONE);

        ret=1;
      }
      break;
// -----
    default:
      ret = pOS_DoAbsMethodA( cl, obj, (struct pOS_Method*)mth );
      break;
  }

  return( ret );
}



/*----------------------------------
Initialisiert alle Daten, ldt erstes Bild & ffnet Fenster
-----------------------------------*/
struct GVData *Setup( ULONG *Ops )
{
  struct GVData *data = (struct GVData*)pOS_AllocVec( sizeof(struct GVData), MEMF_CLEAR );

  if( data ) {
    ULONG WinFlags = WINFLGF_SimpleRefresh;
    struct pOS_DtTypePicture   *Pic = &data->gvd_Pic;
    struct pOS_DtTypePicFrame  *Fra = &data->gvd_Frame;
    struct pOS_TagItem Tags[3] = { SCRTAG_LeftEdge, 0, SCRTAG_TopEdge, 0, TAG_DONE };

/*\
*** FileRequester vorbereiten
*** Wenn wir den Req. zwischendurch nicht lschen, so behlt er seine
*** letzte Position & Abmessung bei.
\*/
    data->gvd_FReq = pOS_AllocFileRequest( PSLFRTAG_PathPart, Ops[0],
      PSLFRTAG_PatternGad, TRUE, TAG_DONE );
    if( !data->gvd_FReq ) {
      Cleanup( data );
      return( NULL );
    }

/*\
*** Gadgetklasse erzeugen
*** Es wird kein Name gesetzt. So ist diese Klasse auch NICHT public.
*** Sie kann nur von uns benutzt werden.
\*/
    data->gvd_Class = pOS_CreateClass( NULL, "gadget.class", NULL,
      (APTR)DragGadDisp, sizeof(struct DragGadData), 0 );
    if( !data->gvd_Class ) {
      Cleanup( data );
      return( NULL );
    }

/*\
*** Das eigentliche Gadget erzeugen.
*** Breite und Hhe werden relativ zur Fenstergre angegeben. Da
*** wir hier noch keine Fensterabmessungen kennen, setzten wir erst
*** mal irgendwelche gltigen Werte.
*** Drag&Drop:
***   Wir knnen DosObjekte und Bilder empfangen.
***   Wir knnen Bilder versenden.
***   Das Gadget wird automatischen seine Rahmenfarbe ndern, falls
***   ein gltiges D&D-Objekt ber ihm ist.
\*/
    data->gvd_Gad = (struct pOS_Gadget*)pOS_NewIObject(
      data->gvd_Class, NULL, 0,
      ICLTAG_GadBorderType,       GADBORTYP_BlkBox,
      ICLTAG_Left,                1,
      ICLTAG_Top,                 1,
      ICLTAG_RelWidth,            -1,
      ICLTAG_RelHeight,           -1,
      ICLTAG_StandardDrop,        TRUE,
      ICLTAG_AddDropAttName,      (ULONG)"#?dosobj/#?",
      ICLTAG_AddDropAttName,      (ULONG)"#?picture/#?",
      ICLTAG_StandardDrag,        TRUE,
      ICLTAG_AddDragAttName,      (ULONG)"/picture/",
      ICLTAG_HighlightDropBox,    TRUE,
      ICLTAG_NoSelect,            TRUE,
      TAG_DONE );
    if( !data->gvd_Gad ) {
      Cleanup( data );
      return( NULL );
    }


/*\
*** DT-Strukturen initialisieren & DataType-Objekt erzeugen
*** DCLTAG_Quick - Der DT soll so schnell wie nur mglich arbeiten.
***    Das kann unter Umstnden dazu fhren, da nicht alle Angaben
***    100%ig gemacht werden knnen. So wird der Gif-DT z.B. nicht
***    nach weiteren Bilder (GifAnims) suchen, sondern nur die
***    allgem. Daten zurckgeben. Als Frameanzahl erscheint dann 0.
\*/
    data->gvd_DCI.dci_Format = pOS_DTFORM_PICTURE;
    Fra->dtpicf_StructSize = sizeof(struct pOS_DtTypePicFrame);
    Pic->dtpic_StructSize  = sizeof(struct pOS_DtTypePicture);

    data->gvd_DType = pOS_CreateFHDTObject( NULL, (CHAR*)Ops[0],
      pOS_DTFORM_PICTURE, Pic, DCLTAG_Quick, TRUE, TAG_DONE );
    if( !data->gvd_DType ) {
      Cleanup( data );
      return( NULL );
    }

/*\
*** GfxMap zum Auslesen des Bildes erzeugen
\*/
    if(!(data->gvd_GfxMap=CreateGfxMap(Pic))) {
      Cleanup( data );
      return( NULL );
    }

/*\
*** Den ersten Frame auslesen.
*** Falls der DT das progressive Laden von Bildern untersttzt, so
*** veranlassen wir ihn, uns, wenn mglich, nur den ersten Progressivteil
*** des Bildes zu laden.
\*/
    Fra->dtpicf_GfxMap   = data->gvd_GfxMap;
    Fra->dtpicf_FrameNum = 1;
    Fra->dtpicf_SubNum   = (Pic->dtpic_Flags & DTPICF_Progressive ) ? ~0 : 0;
    Fra->dtpicf_Flags    = DTPICFRAF_Full;
    Fra->dtpicf_Quality  = pOS_QUALITY_MID;
    Fra->dtpicf_DrawBox  = &data->gvd_DrawBox;

    if(!pOS_ReadDTObjectA(data->gvd_DType,&data->gvd_DCI,Fra,TAG_DONE)) {
      Cleanup( data );
      return( NULL );
    }

/*\
*** Restliche Argumente auswerten & Fenster ffnen.
\*/
    if( Ops[1] == 1 && Ops[3] == 0 && Pic->dtpic_Width > 60 )
      WinFlags |= WINFLGF_CloseGadget;

    if( Ops[3] == 0 )
      WinFlags |= WINFLGF_Dragbar | WINFLGF_DepthGadget | WINFLGF_Activate;

    if( Ops[4] ) Tags[0].ti_Data = *((ULONG*)Ops[4]);
    else         Tags[0].ti_Tag  = TAG_IGNORE;

    if( Ops[5] ) Tags[1].ti_Data = *((ULONG*)Ops[5]);
    else         Tags[1].ti_Tag  = TAG_IGNORE;

    data->gvd_Win = pOS_OpenWindow(
      SCRTAG_Title,          (ULONG)"GfxView V2.0",
      SCRTAG_Flags,          WinFlags,
      SCRTAG_IDCMP,          IDCMP_CloseWindow | IDCMP_RefreshWindow |
                             IDCMP_NewSize | IDCMP_VanillaKey |
                             IDCMP_DragDrop,
      SCRTAG_ZipGadget,      (Ops[3]==0 && Pic->dtpic_Width>100) ? 2 : 0,
      SCRTAG_InnerWidth,     Pic->dtpic_Width,
      SCRTAG_InnerHeight,    Pic->dtpic_Height,
      SCRTAG_MaxWidth,       32000,
      SCRTAG_MaxHeight,      32000,
      SCRTAG_AutoAdjust,     TRUE,
      SCRTAG_AlwaysWinDrag,  Ops[3],
      SCRTAG_UnderMouse,     TRUE,
      SCRTAG_Gadget,         (ULONG)data->gvd_Gad,
      SCRTAGF_Borderless,    Ops[3],
      TAG_MORE,              (ULONG)Tags );

    if( !data->gvd_Win ) {
      Cleanup( data );
      return( NULL );
    }

/*\
*** Inneren Fensterbereich ermitteln & Taskprioritten bei
*** aktiven/inaktiven Fenster festlegen.
\*/
    pOS_GetWindowIBox( data->gvd_Win, &data->gvd_WinBox, NULL );
    pOS_SetWindowTask( data->gvd_Win, pOS_FindTask(NULL), 0, -1 );

/*\
*** Da wir nun die Abmessungen des Fensters kennen, knnen wir das
*** Gadget so positionieren, da es sich genau auf dem inneren Rand
*** befindet.
\*/
    data->gvd_Gad->gad_LeftEdge = data->gvd_WinBox.Left-1;
    data->gvd_Gad->gad_TopEdge  = data->gvd_WinBox.Top-1;
    data->gvd_Gad->gad_Width    = -(data->gvd_Win->win_BorRight + data->gvd_Win->win_BorLeft) +2;
    data->gvd_Gad->gad_Height   = -(data->gvd_Win->win_BorBottom + data->gvd_Win->win_BorTop) +2;

/*\
*** Autom. Animationsabspielen & Progressivladen initialisieren.
***
*** WICHTIG: DTs, die keine genaue Aussage ber die Anzahl der Frames
***          machen knnen, geben im Normalfall NULL als Frameanzahl
***          zurck. Der Gif-DT verhlt sich so, wenn der Quick-Tag
***          beim Erzeugen gesetzt ist.
***          Es wre auch fr einen MPEG-DT denkbar, der am Anfang
***          noch nicht sagen kann, wieviele Bilder sich im Stream
***          befinden.
***          0 ist also als "mglicherweise eine Animation" zu werten.
***
*** Ist die SubNum != 0, so haben wir vorhin den ersten Progressivteil
*** angefordert. Der DT hat jetzt den Aktuellen hier eingetragen. Dieser
*** kann nun abwrts gezhlt werden, um die einzelnen progressiven Teile
*** zu laden.
\*/
    data->gvd_AutoPlay   = Pic->dtpic_Frames != 1;
    data->gvd_Progressiv = Fra->dtpicf_SubNum != 0;
    data->gvd_Delay = data->gvd_AutoPlay ? Fra->dtpicf_Micros : ~0;
    if( data->gvd_Progressiv ) data->gvd_Delay = 5;

/*\
*** Falls wir buffern sollen, legen wir hier das Array mit den BufGfxMap-
*** Strukturen an.
*** Sollte die Anzahl der Frames noch nicht bekannt sein, so merken
*** wir uns das Buffern erst mal.
\*/
    if( Ops[2] ) {
      if( Pic->dtpic_Frames > 1 )
        data->gvd_GfxArray = CreateGfxArray( data );
      else if( Pic->dtpic_Frames == 0 )
        data->gvd_TryToBuffer = TRUE;
    }
  }

  return( data );
}


/*----------------------------------
Alle Resourcen wirder freigeben
-----------------------------------*/
VOID Cleanup( struct GVData *data )
{
  if( data ) {

    if( data->gvd_FReq )     pOS_FreePslRequest( data->gvd_FReq );
    if( data->gvd_Win )      pOS_CloseWindow( data->gvd_Win );

    if( data->gvd_GfxMap )   DeleteGfxMap( data->gvd_GfxMap );
    if( data->gvd_GfxArray ) DeleteGfxArray( data->gvd_GfxArray, data->gvd_Pic.dtpic_Frames+1 );
    if( data->gvd_DType )    pOS_DeleteDTObject( data->gvd_DType );

    if( data->gvd_Gad )      pOS_DisposeIObject( data->gvd_Gad );
    if( data->gvd_Class )    pOS_DeleteClass( data->gvd_Class );

    pOS_FreeVec( data );
  }
}



/*----------------------------------
IDCMP-Nachrichten vom Fenster auswerten
-----------------------------------*/
BOOL HandleIDCMP( struct GVData *data )
{
  BOOL Res = TRUE;

  struct pOS_Window        *Win = data->gvd_Win;
  struct pOS_IntuiMessage  *Msg = NULL;

  while( Res && (Msg=(struct pOS_IntuiMessage*)pOS_GetMsg(Win->win_UserPort))) {

    switch( Msg->im_Class ) {

      case IDCMP_RefreshWindow:
        pOS_BeginRefresh( Win, NULL );
        if( data->gvd_GfxArray && data->gvd_GfxArray[data->gvd_Frame.dtpicf_FrameNum].bgm_GfxMap )
          DrawGfxMap( Win, &data->gvd_WinBox, NULL,
                data->gvd_GfxArray[data->gvd_Frame.dtpicf_FrameNum].bgm_GfxMap );
       else
          DrawGfxMap( Win, &data->gvd_WinBox, NULL, data->gvd_GfxMap );
        pOS_EndRefresh( Win, TRUE );
        break;

      case IDCMP_CloseWindow:
        Res = FALSE;
        break;

      case IDCMP_NewSize:
        pOS_GetWindowIBox( Win, &data->gvd_WinBox, NULL );
        break;

      case IDCMP_DragDrop:
        {
          struct pOS_IEDragDrop *DD = &((struct pOS_ISMDrop*)Msg->im_Data)->ismd_IEDD;

/*\
*** Ein Objekt wurde ber uns losgelassen
\*/
          if( Msg->im_Code == IECODE_DROP_WORK ) {
            if( DD->iedd_Dst.iedd_Gadget == data->gvd_Gad )
              HandleDrop( data, DD );
          }
/*\
*** Drop-Objekt fr den D&D-Partner erzeugen. Da wir Bilder dragen,
*** clonen wir einfach den PictureDT.
\*/
          else if( Msg->im_Code == IECODE_DROP_FIRST ) {
            if( DD->iedd_Src.iedd_Gadget == data->gvd_Gad ) {
              DD->iedd_Object=pOS_CloneDTObject(data->gvd_DType,TAG_DONE);
              if( DD->iedd_Object )
                Msg->im_Code = IECODE_DROP_REPLYWORK;
            }
          }

          if( Msg->im_Code == IECODE_DROP_FIRST )
            if(pOS_SysIMessage(Msg))
              Msg = NULL;
        }
        break;

      case IDCMP_VanillaKey:
        Res = HandleKey( data, Msg->im_Code );
        break;

      default:
        if( pOS_SysIMessage( Msg ))
          Msg = NULL;
        break;
    }
    if( Msg ) pOS_ReplyMsg((struct pOS_Message*)Msg );
  }

  return( Res );
}



/*----------------------------------
Tastatur-Events auswerten
-----------------------------------*/
BOOL HandleKey( struct GVData *data, CHAR key )
{
  BOOL Res=TRUE;

  switch( key ) {
//-----        PLAY
    case 'P':
    case 'p':
      data->gvd_AutoPlay = data->gvd_Pic.dtpic_Frames != 1;
      break;
//-----        QUIT
    case 'Q':
    case 'q':
      Res = FALSE;
      break;
//-----        BUFFER
    case 'b':
      if( !data->gvd_GfxArray ) {
        if( data->gvd_Pic.dtpic_Frames > 1 )
          data->gvd_GfxArray = CreateGfxArray( data );
        else
          data->gvd_TryToBuffer = TRUE;
      }
      break;
//-----        FRONT
    case 'F':
      pOS_WindowToFront( data->gvd_Win );
      break;
//-----        BACK
    case 'B':
      pOS_WindowToBack( data->gvd_Win );
      break;
//-----        OPEN
    case 'O':
    case 'o':
      if( data->gvd_WinBox.Height > 0 )
        OpenNewFile( data );
      break;
//-----
    default:
      data->gvd_AutoPlay = FALSE;
      break;
  }

  return( Res );
}



/*----------------------------------
Auswertung des eintrffenden D&D
-----------------------------------*/
VOID HandleDrop( struct GVData *data, struct pOS_IEDragDrop *dd )
{
  const CHAR *Type=(CHAR*)pOS_GetObjectData(dd->iedd_Object,DCLTAG_Type);

/*\
*** Das ankommende Object ist ein DosObj.
*** Wir lesen den VerzeichnisLock und den Dateinamen aus und
*** laden das neue File
\*/
  if(!stricmp(Type,pOS_DTFORM_DOSOBJ)) {
    CHAR *Buffer = (CHAR*)pOS_AllocMem(1024,MEMF_ANY);

    if( Buffer ) {
      struct pOS_DtTypeDosObj DosObj = {NULL,0,NULL};
      struct pOS_DClassInfo  DCI={pOS_DTFORM_DOSOBJ,NULL,DCLINFOF_None,NULL};

      pOS_DCLASSINFO(&DCI);
      DCI.dci_Data = &DosObj;

      DosObj.dtdos_Buffer = Buffer;
      DosObj.dtdos_BufSize= 1024;
      if(pOS_LoadDTObjectA( dd->iedd_Object, &DCI, NULL )) {
        if( DCI.dci_Result > 0 )
          ShowNewFile( data, DosObj.dtdos_Lock, Buffer, NULL );
      }
      pOS_FreeMem( Buffer, 1024 );
    }
  }
/*\
*** Das ankommende Objekt ist ein Bild.
*** Wir clonen den DT und zeigen das neue Bild an.
\*/
  else if(!stricmp(Type,pOS_DTFORM_PICTURE)) {
    struct pOS_DataType   *DT;
    if( DT = pOS_CloneDTObject( dd->iedd_Object, TAG_DONE )) {
      ShowNewFile( data, NULL, NULL, DT );
    }
  }
}


/*----------------------------------
FileRequester ffnen
-----------------------------------*/
VOID OpenNewFile( struct GVData *data )
{
  struct pOS_PslFileRequester *Req = data->gvd_FReq;
  SLONG  Res;

  Res = pOS_PslFileRequest( Req,
    PSLFRTAG_Title,        (ULONG)"Open...",
    PSLFRTAG_FilterInfos,  TRUE,
    PSLFRTAG_DoubleKlick,  TRUE,
    TAG_DONE );

  if( Res ) {
    struct pOS_FileLock        *DirLk;

    if( DirLk = pOS_LockObject( NULL, Req->pfr_Path, FILELKACC_Shared )) {
      ShowNewFile( data, DirLk, Req->pfr_File, NULL );
      pOS_UnlockObject( DirLk );
    }
  }

  pOS_PslCleanup( Req );
}



/*----------------------------------
Neues Bild/Anim nachladen & altes freigeben
-----------------------------------*/
VOID ShowNewFile( struct GVData *data, struct pOS_FileLock *dirLk,
  const CHAR *name, struct pOS_DataType *DT )
{
  struct pOS_DtTypePicture    Pic;
  struct pOS_DtTypePicFrame   Frame;
  struct pOS_DClassInfo       DCI = {pOS_DTFORM_PICTURE,NULL,DCLINFOF_None,NULL};
  struct pOS_GfxMap          *GfxMap;

  pOS_DCLASSINFO(&DCI);
  DCI.dci_Data = &Pic;
  memset(&Frame, 0, sizeof(Frame));
  memset(&Pic,   0, sizeof(Pic)  );
  Frame.dtpicf_StructSize = sizeof(Frame);
  Pic.dtpic_StructSize    = sizeof(Pic);

/*\
*** Wenn wir einen DataType mit bergeben bekommen haben, so brauchen
*** wir hier keinen neuen zu erzeugen. Allerdings wissen wir noch
*** nicht ber das Bild, so da wir einfach nochmal ein DCLMTH_Obtain
*** fahren, um die pOS_DtTypePicture-Struktur zu fllen.
\*/
  if( DT ) {
    struct pOS_DtTypeMethod Mth;
    Mth.dtth_Method = DCLMTH_Obtain;
    Mth.dtth_U.dtth_Obtain.dtob_Tags = TAG_DONE;
    Mth.dtth_U.dtth_Obtain.dtob_Info = &DCI;

    if(pOS_DoIMethodA(DT,(struct pOS_Method*)&Mth) == pOS_CLASSERR) {
      pOS_DeleteDTObject( DT );
      DT = NULL;
    }
  }
  else {
    DT = pOS_CreateFHDTObject( dirLk, name, pOS_DTFORM_PICTURE, &Pic,
           DCLTAG_Quick, TRUE, NULL );
  }

  if( DT ) {
    struct pOS_IBox *Box = &data->gvd_WinBox;
    pOS_EraseRect( data->gvd_Win->win_RastPort, Box->Left, Box->Top,
      Box->Left + Box->Width -1, Box->Top + Box->Height -1 );

/*\
*** Neue GfxMap erzeugen, pOS_DtTypePicFrame initialisieren &
*** ersten Frame lesen
\*/
    if( GfxMap = CreateGfxMap( &Pic )) {
      Frame.dtpicf_GfxMap      = GfxMap;
      Frame.dtpicf_ActFrameNum = 0;
      Frame.dtpicf_FrameNum    = 1;
      Frame.dtpicf_SubNum      = (Pic.dtpic_Flags & DTPICF_Progressive ) ? ~0 : 0;
      Frame.dtpicf_Flags       = DTPICFRAF_Full;
      Frame.dtpicf_Quality     = pOS_QUALITY_MID;
      Frame.dtpicf_DrawBox     = &data->gvd_DrawBox;

      if( pOS_ReadDTObjectA( DT, &DCI, &Frame, TAG_DONE )) {
        struct pOS_Window *Win = data->gvd_Win;
        struct pOS_Screen *Scr = Win->win_Screen;
/*\
*** Neue Fenstergre berechnen & Fenster neu positionieren.
\*/
        SLONG nWidth = Pic.dtpic_Width + Win->win_BorLeft + Win->win_BorRight;
        SLONG nHeight= Pic.dtpic_Height + Win->win_BorTop + Win->win_BorBottom;
        SLONG nLeft  = Scr->scr_Width - nWidth;
        SLONG nTop   = Scr->scr_Height - nHeight;
        nLeft = MIN(Win->win_LeftEdge,nLeft);
        nTop  = MIN(Win->win_TopEdge,nTop);
        nLeft = MAX(nLeft,0);
        nTop  = MAX(nTop,0);

        if( pOS_ChangeWindowBox( Win, nLeft, nTop, nWidth, nHeight )) {
/*\
*** alle alten Daten lschen / freigeben
\*/
          if( data->gvd_GfxArray )
            DeleteGfxArray( data->gvd_GfxArray, data->gvd_Pic.dtpic_Frames+1 );
          data->gvd_GfxArray = NULL;
          if( data->gvd_GfxMap ) DeleteGfxMap( data->gvd_GfxMap );
          if( data->gvd_DType  ) pOS_DeleteDTObject( data->gvd_DType );

/*\
*** alle Strukturen mit neue Werte beschreiben
\*/
          data->gvd_GfxMap = GfxMap;
          data->gvd_DType  = DT;
          pOS_CopyMem( &Pic, &data->gvd_Pic, sizeof(struct pOS_DtTypePicture));
          pOS_CopyMem( &Frame, &data->gvd_Frame, sizeof(struct pOS_DtTypePicFrame));
          pOS_CopyMem( &DCI, &data->gvd_DCI, sizeof(struct pOS_DClassInfo));
          pOS_GetWindowIBox( data->gvd_Win, &data->gvd_WinBox, NULL );

          data->gvd_AutoPlay = Pic.dtpic_Frames != 1;
          data->gvd_Progressiv = Frame.dtpicf_SubNum != 0;
          data->gvd_Delay = data->gvd_AutoPlay ? Frame.dtpicf_Micros : ~0;
          if( data->gvd_Progressiv ) data->gvd_Delay = 5;

          DrawGfxMap( Win, &data->gvd_WinBox, NULL, GfxMap );
        }
        else {
          DeleteGfxMap( GfxMap );
          pOS_DeleteDTObject( DT );
        }
      }
      else {
        DeleteGfxMap( GfxMap );
        pOS_DeleteDTObject( DT );
      }
    }
    else pOS_DeleteDTObject( DT );
  }
  else pOS_DisplayBeep( NULL, BEEPTYP_Warn );
}


/*----------------------------------
Laden und Anzeigen des nchsten ProgressivTeils
-----------------------------------*/
VOID ShowNextProgressivFrame( struct GVData *data )
{
  struct pOS_DtTypePicFrame *Fra = &data->gvd_Frame;

/*\
*** aktueller PTail ist der zuletzt gelesene
*** Wir wollen den nchsten Laden.
\*/
  Fra->dtpicf_ActSubNum = Fra->dtpicf_SubNum--;
  if(pOS_ReadDTObjectA(data->gvd_DType,&data->gvd_DCI,Fra,TAG_DONE)) {
    DrawGfxMap(data->gvd_Win,&data->gvd_WinBox,
      Fra->dtpicf_DrawBox, data->gvd_GfxMap );

/*\
*** Wenn SubNum == 0  =>  letzter ProgressivTeil geladen, dann
*** in den normalen Mode wechseln.
\*/
    if( Fra->dtpicf_SubNum )
      data->gvd_Delay = 5;
    else {
      data->gvd_Delay = Fra->dtpicf_Micros;
      data->gvd_Progressiv = FALSE;
    }
  }
  else data->gvd_Progressiv = FALSE;
}


/*----------------------------------
Laden und Anzeigen des nchsten Frames einer Anim
-----------------------------------*/
VOID ShowNextAnimFrame( struct GVData *data )
{
  struct pOS_DtTypePicFrame  *Fra = &data->gvd_Frame;

/*\
*** Wir haben noch keine Informationen ber die wirkliche Anzahl der
*** enthaltenen Frames. Also versuchen wir erst mal den nchsten Frame
*** zu lesen. Sollte das Fehlschlagen, haben wir die Anzahl der Frames.
\*/
  if( data->gvd_Pic.dtpic_Frames == 0 ) {
    Fra->dtpicf_ActFrameNum = Fra->dtpicf_FrameNum++;
    if( !pOS_ReadDTObjectA( data->gvd_DType, &data->gvd_DCI, Fra, TAG_DONE )) {
      data->gvd_Pic.dtpic_Frames = Fra->dtpicf_ActFrameNum;
      if( data->gvd_Pic.dtpic_Frames > 1 ) {
        Fra->dtpicf_FrameNum = 1;
        pOS_ReadDTObjectA( data->gvd_DType, &data->gvd_DCI, Fra, TAG_DONE );
        DrawGfxMap( data->gvd_Win, &data->gvd_WinBox, Fra->dtpicf_DrawBox, data->gvd_GfxMap );
        data->gvd_Delay = Fra->dtpicf_Micros;

        if( data->gvd_TryToBuffer ) {
          data->gvd_TryToBuffer = FALSE;
          data->gvd_GfxArray = CreateGfxArray( data );
        }
      }
      else {
        data->gvd_Delay = ~0;
        data->gvd_AutoPlay = FALSE;
      }
    }
    else {
      DrawGfxMap( data->gvd_Win, &data->gvd_WinBox, Fra->dtpicf_DrawBox, data->gvd_GfxMap );
      data->gvd_Delay = Fra->dtpicf_Micros;
    }
  }
/*\
*** Wir kennen die Anzahl der Frames.
\*/
  else {
    struct BufGfxMap *Cur;

    Fra->dtpicf_ActFrameNum = Fra->dtpicf_FrameNum++;
    if( Fra->dtpicf_FrameNum > data->gvd_Pic.dtpic_Frames )
      Fra->dtpicf_FrameNum = 1;

/*\
*** Sollte ein Array zur Bufferung vorhanden und an der aktuellen
*** Stelle ein Eintrag sein, so verwenden wir die gebufferte GfxMap
*** zum Anzeigen. Im anderen Fall laden wir den aktuellen Frame
*** vom DT.
\*/
    Cur = data->gvd_GfxArray ? &data->gvd_GfxArray[Fra->dtpicf_FrameNum] : NULL;

    if( Cur && Cur->bgm_GfxMap ) {
      DrawGfxMap( data->gvd_Win, &data->gvd_WinBox, &Cur->bgm_Box, Cur->bgm_GfxMap );
      data->gvd_Delay = Cur->bgm_Delay;
    }
    else {
      pOS_ReadDTObjectA( data->gvd_DType, &data->gvd_DCI, Fra, TAG_DONE );
      DrawGfxMap( data->gvd_Win, &data->gvd_WinBox, Fra->dtpicf_DrawBox, data->gvd_GfxMap );
      data->gvd_Delay = Fra->dtpicf_Micros;

/*\
*** Es ist zwar ein Array zum Buffern vorhanden, aber die GfxMap war
*** noch nicht zwischengespeichert. Wir fgen sie nun hinzu.
\*/
      if( Cur ) AddToGfxArray( Cur, data );
    }
  }
}



/*----------------------------------
Zeichnet eine GfxMap in das Fenster.

box - Das ist die innere Abmessung unseres Fensters und damit unser
      maximaler Zeichenbereich.

drawBox - Das ist der Bereich, welcher aus der GfxMap neu gezeichnet
          werden soll. Das macht z.B. bei Gif-Anims sinn, da in ihnen
          auch Frames vorhanden sein knnen, welche nur Teile des
          kompletten Bildes berschreiben.
-----------------------------------*/
VOID DrawGfxMap(struct pOS_Window *win,struct pOS_IBox *box,
  struct pOS_IBox *drawBox,struct pOS_GfxMap *map )
{
  if( drawBox ) {
    struct pOS_IBox  Rec;

    Rec.Left   = box->Left + drawBox->Left;
    Rec.Top    = box->Top  + drawBox->Top;
    Rec.Width  = MIN( drawBox->Width,  box->Width - drawBox->Left );
    Rec.Height = MIN( drawBox->Height, box->Height - drawBox->Top );

    if( Rec.Width > 0 && Rec.Height > 0 )
      pOS_WriteStdGfxMapRastPort( map, drawBox->Left, drawBox->Top,
        win->win_RastPort, Rec.Left, Rec.Top, Rec.Width, Rec.Height, 0 );
  }
  else {
    pOS_WriteStdGfxMapRastPort( map, 0, 0,
      win->win_RastPort, box->Left, box->Top,
      box->Width, box->Height, 0 );
  }
}



/*----------------------------------
Erzeugt eine StdGfxMap entsprechend den Daten der pOS_DtTypePicture-
Struktur
-----------------------------------*/
__ARID__ struct pOS_GfxMap *CreateGfxMap( struct pOS_DtTypePicture *pic )
{
  struct pOS_GfxMap    *GfxMap;
  struct pOS_ColorMap  *ColorMap = NULL;

  if(pic->dtpic_ColorMapType!=COLMAPTYP_None) {
    ColorMap=pOS_AllocColorMap(NULL,
             GFXTAG_ColorType, pic->dtpic_ColorMapType,
             GFXTAG_Colors,    pic->dtpic_Colors,
             TAG_END);

    if( !ColorMap ) return(NULL);
  }

  GfxMap = pOS_AllocGfxMap(NULL,
    GFXTAG_Width,       pic->dtpic_Width,
    GFXTAG_Height,      pic->dtpic_Height,
    GFXTAG_GfxType,     pic->dtpic_GfxMapType,
    GFXTAG_CrtGfxMapEx, TRUE,
    GFXTAG_ColorMap,    (ULONG)ColorMap,
    TAG_END);


  return( GfxMap );
}



/*----------------------------------
Lscht StdGfxMap
-----------------------------------*/
VOID DeleteGfxMap( __ARID__ struct pOS_GfxMap *map )
{
  if( map->gm_Ex && map->gm_Ex->gme_ColorMap)
    pOS_FreeColorMap(map->gm_Ex->gme_ColorMap);

  pOS_FreeGfxMap( map );
}



/*----------------------------------
Erzeugt Array[Frames+1] fr gebuffertes Abspielen
-----------------------------------*/
__ARID__ struct BufGfxMap *CreateGfxArray( struct GVData *data )
{
  struct pOS_DtTypePicture *Pic = &data->gvd_Pic;
  struct BufGfxMap         *array = NULL;

  if( Pic->dtpic_Frames > 1 ) {
    array = (struct BufGfxMap*)pOS_AllocVec(
      sizeof(struct BufGfxMap)*(Pic->dtpic_Frames+1),MEMF_ANY|MEMF_CLEAR);
  }

  return( array );
}



/*----------------------------------
Lscht Buffering-Array und gibt alle FriendGfxMaps frei
-----------------------------------*/
VOID DeleteGfxArray( __ARID__ struct BufGfxMap *array, ULONG num )
{
  ULONG Cnt;

  for( Cnt=0; Cnt<num; ++Cnt )
    if( array[Cnt].bgm_GfxMap ) pOS_FreeGfxMap( array[Cnt].bgm_GfxMap );

  pOS_FreeVec( array );
}



/*----------------------------------
Fgt die aktuelle GfxMap dem Buffering hinzu
-----------------------------------*/
VOID AddToGfxArray( struct BufGfxMap *bmap, struct GVData *data )
{
  struct pOS_RastPort        *RP  = data->gvd_Win->win_RastPort;
  struct pOS_DtTypePicture   *Pic = &data->gvd_Pic;
  struct pOS_DtTypePicFrame  *Fra = &data->gvd_Frame;

/*\
*** Friend-GfxMap erzeugen, deren Dimensionen unserer StdGfxMap
*** entsprichen.
*** Bei Erzeugen einer FriendGfxMap ist unbedingt der RTG-Treiber
*** RP->rp_Base mitanzugeben.
*** Die Kombination der Tags GFXTAG_CrtGfxMap & GFXTAG_StdGfxMap
*** bewirkt, da die neue FriendMap gleich mit den umgerechneten
*** Bilddaten gefllt wird. Das Bild mu nicht extra mit
*** pOS_WriteStdGfxMap() konvertiert werden.
\*/
  bmap->bgm_GfxMap = pOS_AllocGfxMap( RP->rp_Base,
    GFXTAG_Width,         Pic->dtpic_Width,
    GFXTAG_Height,        Pic->dtpic_Height,
    GFXTAG_CrtExtraMap,   TRUE,
    GFXTAG_StdGfxMap,     (ULONG)Fra->dtpicf_GfxMap,
    GFXTAG_FriendGfxMap,  (ULONG)RP->rp_GfxMap,
    TAG_END );

/*\
*** Wenn eine DrawBox vorhanden ist, diese auch mitkopieren.
*** FrameDelay-Zeit merken.
\*/
  if( bmap->bgm_GfxMap ) {
    if( Fra->dtpicf_DrawBox ) {
      pOS_CopyMem( Fra->dtpicf_DrawBox, &bmap->bgm_Box, sizeof(struct pOS_IBox));
    }
    else {
      bmap->bgm_Box.Left   = 0;
      bmap->bgm_Box.Top    = 0;
      bmap->bgm_Box.Width  = Pic->dtpic_Width;
      bmap->bgm_Box.Height = Pic->dtpic_Height;
    }
    bmap->bgm_Delay = Fra->dtpicf_Micros;
  }
  else {
    DeleteGfxArray( data->gvd_GfxArray, Pic->dtpic_Frames+1 );
    data->gvd_GfxArray = NULL;
  }
}


