
/*******************************************************************
 $CRT 05 Mar 1997 : hb

 $AUT Holger Burkarth
 $DAT >>But1.c<<   05 Mar 1997    08:59:57 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/Ex/But1 p:pLib/StartCode.o p:/pOS_RKRM/pIntui/But1.c p:pLib/StdIO.o -l pOSStub -l pOS

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

/*\
*** Example:
***
\*/


#define __COMPUTER_AMIGA 1
#define NOMYDEBUG

#include "p:pExec/Types.h"
#include "p:pDOS/ArgTags.h"
#include "p:pDOS/DosSig.h"
#include "p:pDOS/DosErrors.h"
#include "p:pGadget/Gadget.h"
#include "p:pScreen/ScrTags.h"
#include "p:pScreen/Window.h"
#include "p:pScreen/Screen.h"
#include "p:pIntui/IntuMsg.h"
#include "p:pIntui/FraClass.h"
#include "p:pIntui/OClass.h"
#include "p:pIntui/IObj.h"
#include "p:pIntui/Tags.h"
#include "p:proto/pExec2.h"
#include "p:proto/pDOS2.h"
#include "p:proto/pIntui2.h"

#ifdef _____ME_____
  #include "grund/inc_string.h"
  #include "grund/inc_stdio.h"
#else
 #ifdef __cplusplus
 extern "C" {
 #endif
  #include <string.h>
  #include <stdio.h>
 #ifdef __cplusplus
 }
 #endif
#endif


const CHAR *HelpText=
""
;

const CHAR *PrgHeader=
"";

const CHAR *PrgVerText=
"$VER: 1.0 ("__DATE2__") (Copyright 1997 by proDAD) (Created by Holger Burkarth)";


struct pOS_IntuiDevice *gb_IntuiBase;



/*----------------------------------
-----------------------------------*/
#ifdef __cplusplus
extern "C"
#endif

VOID main()
{
  struct pOS_DosArgs* Args;
  UWORD Err=0;
  ULONG Ops[1]={0};

/*\
*** Bentigte Libs ffnen
\*/
  gb_IntuiBase=(struct pOS_IntuiDevice*)pOS_OpenLibrary("pintui.library",0);


  Args=pOS_ReadDosArgs(
//
"",
Ops,sizeof(Ops)/sizeof(ULONG),

    ARGTAG_PrgHeaderText, (ULONG)PrgHeader,    /* kurze Programm-Beschreibung */
    ARGTAG_HelpText,      (ULONG)HelpText,     /* Help-Texte */
    ARGTAG_PrgVerText,    (ULONG)PrgVerText,   /* VER-String */
    TAG_END);

  if(Args) {
    struct pOS_Screen *Scr;
    struct pOS_Window *Win;
    struct pOS_Gadget *Gad,*But1Gad;

    if(Scr=pOS_LockPubScreen(NULL)) {
      const struct pOS_DrawInfo *const Dri=Scr->scr_DrawInfo;

      But1Gad=(struct pOS_Gadget*)pOS_NewIObject(NULL,"gadget.class",0,
        ICLTAG_DrawInfo,      (ULONG)Dri,
        ICLTAG_StdLableName,  (ULONG)"Light",
        ICLTAG_RelVerify,     TRUE,
        ICLTAG_LableLayMode,  IOBLAY_Right,
        ICLTAG_Render,        (ULONG)pOS_NewIObject(NULL,"isymbol.class",0,
                           ICLTAG_Width, 16,
                           ICLTAG_Height,12,
                           ICLTAG_FrameType, IFRACLTYP_Button,
                           TAG_END),
        TAG_DONE);


/*\
*** Gesamte Gadget-Gruppe bilden.
\*/
      Gad=(struct pOS_Gadget*)pOS_NewIObject(NULL,Dri->dri_Names[SCRNAM_GGroupClass],0,
        ICLTAG_AutoDelete,    TRUE,
        GRPGADTAG_BorLeft,    8,
        GRPGADTAG_BorTop,     8,
        GRPGADTAG_BorRight,   8,
        GRPGADTAG_BorBottom,  8,
        GRPGADTAG_SpaceVert,  8,
        GRPGADTAG_AddGadget,   (ULONG)But1Gad,
        ICLTAG_Gwk,           1,
        TAG_DONE);

      Win=pOS_OpenWindow(
          SCRTAG_Title,   (ULONG)"Button-1",
          SCRTAG_Screen,  (ULONG)Scr,
          SCRTAG_Flags,   WINFLGF_DepthGadget | WINFLGF_SimpleRefresh | WINFLGF_SizeGadget |
                          WINFLGF_Activate | WINFLGF_CloseGadget | WINFLGF_Dragbar,
          SCRTAG_IDCMP,   IDCMP_CloseWindow | IDCMP_StdSysMsg,
          SCRTAG_AutoSizeGadget, (ULONG)Gad,
          SCRTAG_UnderMouse,     TRUE,
          TAG_DONE);

      if(Win) {
        struct pOS_IntuiMessage *Msg;
        ULONG Counter=0;
        BOOL Ende=FALSE,Run=TRUE;

        while(!Ende) {
          ULONG Sig;

          Sig=pOS_WaitSignal( (1<<Win->win_UserPort->mp_SigBit) | DOSSIGF_CTRL_C);
          if(Sig & DOSSIGF_CTRL_C) Ende=TRUE;

          while(Msg=(struct pOS_IntuiMessage*)pOS_GetMsg(Win->win_UserPort)) {
            switch(Msg->im_Class) {

              case IDCMP_GadgetUp:
                if(Msg->im_IAddress==(APTR)But1Gad) {
                  printf("Gadget 'But1Gad'\n"); Run=TRUE;
                }
                break;

              case IDCMP_CloseWindow:  Ende=TRUE; break;

/*\
*** Nachrichtenauswertung ans System weiterreichen. (Refresh)
\*/
              default: if(pOS_SysIMessage(Msg)) Msg=NULL;
            }

            if(Msg) pOS_ReplyMsg(&Msg->im_Message);
          }
        }
        pOS_CloseWindow(Win);
      }
      else printf("Cannot open window\n");
      pOS_UnlockPubScreen(Scr);
    }
    else printf("Cannot lock PubScreen\n");

    pOS_DeleteDosArgs(Args);  /* Args freigeben */
  }
  else Err=DOSFAIL_FAIL;  /* vollkommen fehlgeschlagen */

  pOS_SetShellFail(Err);

/*\
*** Libs wieder schlieen
\*/
  pOS_CloseLibrary((struct pOS_Library*)gb_IntuiBase);
}

