
/*******************************************************************
 $CRT 02 Jun 1996 : hb

 $AUT Holger Burkarth
 $DAT >>EReq.c<<   29 Jan 1997    13:23:14 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/Ex/EReq p:pLib/StartCode.o p:/pOS_RKRM/pIntui/EReq.c p:pLib/StdIO.o -l pOSStub -l pOS

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

/*\
*** Example:
*** struct pOS_EasyStruct
*** struct pOS_TagItem
***
*** pOS_CreateRequestWinA
*** pOS_RequestWinHandler
*** pOS_DeleteRequestWin
*** pOS_EasyRequestArgs
***
\*/


#define __COMPUTER_AMIGA 1
#define NOMYDEBUG

#include "p:pExec/Types.h"
#include "p:pDOS/ArgTags.h"
#include "p:pDOS/DosSig.h"
#include "p:pDOS/DosErrors.h"
#include "p:pScreen/ScrTags.h"
#include "p:pScreen/Window.h"
#include "p:pScreen/Screen.h"
#include "p:pIntui/EasyReq.h"
#include "p:pIntui/EasyTags.h"
#include "p:pIntui/IntuMsg.h"
#include "p:pIntui/Tags.h"
#include "p:proto/pLibExt.h"
#include "p:proto/pExec2.h"
#include "p:proto/pDOS2.h"
#include "p:proto/pIntui2.h"

#ifdef _____ME_____
  #include "grund/inc_string.h"
  #include "grund/inc_stdio.h"
#else
 #ifdef __cplusplus
 extern "C" {
 #endif
  #include <string.h>
  #include <stdio.h>
 #ifdef __cplusplus
 }
 #endif
#endif


const CHAR *HelpText=
""
;

const CHAR *PrgHeader=
"Requester-Demo";

const CHAR *PrgVerText=
"$VER: 1.0 ("__DATE2__") (Copyright 1996-97 by proDAD) (Created by Holger Burkarth)";


struct pOS_IntuiDevice *gb_IntuiBase;

/*----------------------------------
-----------------------------------*/
#ifdef __cplusplus
extern "C"
#endif

VOID main()
{
  struct pOS_DosArgs* Args;
  UWORD Err=0;
  ULONG Ops[1]={0};

  gb_IntuiBase=(struct pOS_IntuiDevice*)pOS_OpenLibrary("pintui.library",0);


  Args=pOS_ReadDosArgs(
//  0
"CLASSNAME",
Ops,sizeof(Ops)/sizeof(ULONG),

    ARGTAG_PrgHeaderText, (ULONG)PrgHeader,    /* kurze Programm-Beschreibung */
    ARGTAG_HelpText,      (ULONG)HelpText,     /* Help-Texte */
    ARGTAG_PrgVerText,    (ULONG)PrgVerText,   /* VER-String */
    TAG_END);

  if(Args) {
    struct pOS_Window *Win;
    struct pOS_Gadget *Gad=NULL;
    SLONG Ret;
    struct pOS_EasyStruct ES={
      sizeof(struct pOS_EasyStruct),
      0,0,
      "Window-Title",
      "Test-Requester\n\n%s",
      "_Ok|%ld|_Cancel",
      NULL,NULL
    };

    if(Ops[0]) {
      struct pOS_Screen *Scr;
      if(Scr=pOS_LockPubScreen("Workbench")) {
        Gad=(struct pOS_Gadget*)pOS_NewIObject(NULL,(CHAR*)Ops[0],0,
           ICLTAG_DrawInfo,  (ULONG)Scr->scr_DrawInfo,
           ICLTAG_Gwk,       1,
           TAG_DONE);

        if(Gad==NULL) {
          printf("Cannot create gadget <%s>\n",Ops[0]);
        }
        else {
          ES.es_TextFormat=NULL;
        }

        pOS_UnlockPubScreen(Scr);
      }
      else printf("Cannot lock PubScreen 'Workbench'\n");
    }


    {
      ULONG Argv[]={(ULONG)"Press Ctrl-C for break",12};

      struct pOS_TagItem Tags[]={
        EASYTAG_ES,        (ULONG)&ES,
        EASYTAG_Args,      (ULONG)Argv,
        SCRTAG_IDCMP,      IDCMP_StdSysMsg, // IDCMP_GadgetUp | IDCMP_VanillaKey,
        EASYTAG_Gadget,    (ULONG)Gad,
        TAG_END};

      if(Win=pOS_CreateRequestWinA(Tags)) {
        for(;;) {
          Ret=pOS_RequestWinHandler(Win,NULL,FALSE);
          if(Ret==-2 || Ret==-1) {
            Ret=pOS_WaitSignal((1<<Win->win_UserPort->mp_SigBit) | DOSSIGF_CTRL_C);
            if(Ret & DOSSIGF_CTRL_C) {Ret=-2; break;}
          }
          else break;
        }
        pOS_DeleteRequestWin(Win);
      }
      printf("Result = %ld\n",Ret);
    }

    if(Gad==NULL) {
      ULONG Argv[]={(ULONG)"Synchron-Requester",24};
      Ret=pOS_EasyRequestArgs(NULL,&ES,NULL,Argv);
      printf("Result = %ld\n",Ret);
    }
    if(Gad) pOS_DisposeIObject((APTR)Gad);

    pOS_DeleteDosArgs(Args);  /* Args freigeben */
  }
  else Err=DOSFAIL_FAIL;  /* vollkommen fehlgeschlagen */

  pOS_SetShellFail(Err);

  pOS_CloseLibrary((pOS_Library*)gb_IntuiBase);
}
