
/*******************************************************************
 $CRT 21 Dec 1996 : hb

 $AUT Holger Burkarth
 $DAT >>ReqType.c<<   28 Feb 1997    11:47:33 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/Ex/ReqType p:pLib/StartCode.o p:/pOS_RKRM/pIntui/ReqType.c p:pLib/StdIO.o -l pOSStub -l pOS

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

/*\
*** Example:
***
\*/


#define __COMPUTER_AMIGA 1
#define NOMYDEBUG

#include "p:pExec/Types.h"
#include "p:pDOS/ArgTags.h"
#include "p:pDOS/DosSig.h"
#include "p:pDOS/DosErrors.h"
#include "p:pGadget/Gadget.h"
#include "p:pGadget/GadItem.h"
#include "p:pGadget/PropGad.h"
#include "p:pScreen/ScrTags.h"
#include "p:pScreen/Window.h"
#include "p:pScreen/Screen.h"
#include "p:pIntui/IntuMsg.h"
#include "p:pIntui/Tags.h"
#include "p:pIntui/IType.h"
#include "p:pIntui/EasyReq.h"
#include "p:proto/pExec2.h"
#include "p:proto/pDOS2.h"
#include "p:proto/pIntui2.h"

#ifdef _____ME_____
  #include "grund/inc_string.h"
  #include "grund/inc_stdio.h"
#else
 #ifdef __cplusplus
 extern "C" {
 #endif
  #include <string.h>
  #include <stdio.h>
 #ifdef __cplusplus
 }
 #endif
#endif


const CHAR *HelpText=
""
;

const CHAR *PrgHeader=
"";

const CHAR *PrgVerText=
"$VER: 2.0 ("__DATE2__") (Copyright 1996-97 by proDAD) (Created by Holger Burkarth)";


struct pOS_IntuiDevice *gb_IntuiBase;


static const pOS_GadgetTagItem gb_LVArray[]={
  {"Std",                      ESYTYP_Std},
  {"Request",                  ESYTYP_Request},
  {"NoMem",                    ESYTYP_NoMem},
  {"Input",                    ESYTYP_Input},
  {"DiskWriteProtected",       ESYTYP_DiskWriteProtected},
  {"DeviceNotMounted",         ESYTYP_DeviceNotMounted},
  {"DiskFull",                 ESYTYP_DiskFull},
  {"NotDosDisk",               ESYTYP_NotDosDisk},
  {"NoDiskInDrive",            ESYTYP_NoDiskInDrive},
  {"ReadWriteError",           ESYTYP_ReadWriteError},
  {"Error",                    ESYTYP_Error},
  {"Warn",                     ESYTYP_Warn},
  {"Safety",                   ESYTYP_Safety},
  {"Info",                     ESYTYP_Info},
  {NULL}
};



/*----------------------------------
-----------------------------------*/
BOOL OpenReq(ULONG type,const CHAR* title,
             const CHAR* body,const CHAR* butt,struct pOS_Window *mainWin)
{
  pOS_EasyStruct ES;
  CHAR Buffer1[128];
  CHAR Buffer2[128];
  UWORD i;
  memset(&ES,0,sizeof(ES));

  for(i=0; body[i] && i<sizeof(Buffer1)-1; ++i) {
    Buffer1[i]=body[i] != '*' ? body[i]:'\n';
  }
  Buffer1[i]='\0';

  for(i=0; butt[i] && i<sizeof(Buffer2)-1; ++i) {
    Buffer2[i]=butt[i] != '*' ? butt[i]:'\n';
  }
  Buffer2[i]='\0';

  ES.es_StructSize=sizeof(ES);
  ES.es_Type=type;
  ES.es_Title=title;
  ES.es_TextFormat  =Buffer1;
  ES.es_GadgetFormat=Buffer2;
  return( pOS_EasyRequestArgs(mainWin,&ES,NULL,NULL) >= 0 );
}




/*----------------------------------
-----------------------------------*/
#ifdef __cplusplus
extern "C"
#endif

VOID main()
{
  struct pOS_DosArgs* Args;
  UWORD Err=0;
  ULONG Ops[1]={0};

  gb_IntuiBase=(struct pOS_IntuiDevice*)pOS_OpenLibrary("pintui.library",0);

  Args=pOS_ReadDosArgs(
//
"",
Ops,sizeof(Ops)/sizeof(ULONG),

    ARGTAG_PrgHeaderText, (ULONG)PrgHeader,    /* kurze Programm-Beschreibung */
    ARGTAG_HelpText,      (ULONG)HelpText,     /* Help-Texte */
    ARGTAG_PrgVerText,    (ULONG)PrgVerText,   /* VER-String */
    TAG_END);


  if(Args) {
    struct pOS_Window *Win;
    struct pOS_Screen *Scr;
    struct pOS_Gadget *VGrpGad;
    struct pOS_Gadget *LVGad;
    struct pOS_Gadget *BodyStrGad;
    struct pOS_Gadget *ButtStrGad;
    struct pOS_Gadget *SlideGad;
    struct pOS_Gadget *TestGad;

    if(Scr=pOS_LockPubScreen(NULL)) {
      const struct pOS_DrawInfo *const Dri=Scr->scr_DrawInfo;

      LVGad=(struct pOS_Gadget*)pOS_NewIObject(NULL,Dri->dri_Names[SCRNAM_GLVClass],0,
        ICLTAG_DrawInfo,       (ULONG)Dri,
        ICLTAG_Immediate,      TRUE,
        ICLTAG_RelVerify,      TRUE,
        ICLTAG_UpdateGadget,   TRUE,
        ICLTAG_Gwk,            1,
        LVGADTAG_GadgetTagItem,(ULONG)gb_LVArray,
        LVGADTAG_CursorScroll, TRUE,
        LVGADTAG_CursorSelect, TRUE,
        LVGADTAG_AlwaysOne,    TRUE,
        LVGADTAG_VAutoGad,     TRUE,
        LVGADTAG_Key1,         TRUE,
        LVGADTAG_CR,           TRUE,
        LVGADTAG_ESC,          TRUE,
        TAG_DONE);

      SlideGad=(struct pOS_Gadget*)pOS_NewIObject(NULL,Dri->dri_Names[SCRNAM_GPropClass],0,
        ICLTAG_DrawInfo,       (ULONG)Dri,
        ICLTAG_Immediate,      TRUE,
        ICLTAG_UpdateGadget,   TRUE,
        PRGADTAG_Flags,        PRGADF_FreeHoriz,
        PRGADTAG_Total,        ESYTYP_MAX-ESYTYP_Request+1,
        PRGADTAG_Visible,      1,
        PRGADTAG_CreateUDGads, TRUE,
        PRGADTAG_Fmt,          (ULONG)"# %ld",
        PRGADTAG_CrtTxtObj,    TRUE,
        ICLTAG_StdLableName,   (ULONG)"_Slider",
        TAG_DONE);

      BodyStrGad=(struct pOS_Gadget*)pOS_NewIObject(NULL,Dri->dri_Names[SCRNAM_GStrClass],0,
        ICLTAG_DrawInfo,       (ULONG)Dri,
        STRGADTAG_String,      (ULONG)"ReqType**T E S T",
        ICLTAG_StdLableName,   (ULONG)"_Body:",
        TAG_DONE);

      ButtStrGad=(struct pOS_Gadget*)pOS_NewIObject(NULL,Dri->dri_Names[SCRNAM_GStrClass],0,
        ICLTAG_DrawInfo,       (ULONG)Dri,
        STRGADTAG_String,      (ULONG)"_Ok",
        ICLTAG_StdLableName,   (ULONG)"_Gads:",
        TAG_DONE);

      TestGad=(struct pOS_Gadget*)pOS_NewIObject(NULL,Dri->dri_Names[SCRNAM_GButtonClass],0,
        ICLTAG_DrawInfo,       (ULONG)Dri,
        IOBJTAG_StaticString,  (ULONG)"_Test",
        TAG_DONE);

      VGrpGad=(struct pOS_Gadget*)pOS_NewIObject(NULL,Dri->dri_Names[SCRNAM_GGroupClass],0,
        ICLTAG_AutoDelete,     TRUE,
        GRPGADTAG_BorLeft,     8,
        GRPGADTAG_BorTop,      8,
        GRPGADTAG_BorRight,    8,
        GRPGADTAG_BorBottom,   8,
        GRPGADTAG_SpaceVert,   4,
        GRPGADTAG_AddGadget,   (ULONG)LVGad,
        GRPGADTAG_AddGadget,   (ULONG)SlideGad,
        GRPGADTAG_AddGadget,   (ULONG)BodyStrGad,
        GRPGADTAG_AddGadget,   (ULONG)ButtStrGad,
        GRPGADTAG_AddGadget,   (ULONG)TestGad,
        GRPGADTAG_AdjustLables,TRUE,
        TAG_DONE);


      if(VGrpGad) {
        Win=pOS_OpenWindow(
              SCRTAG_Title,    (ULONG)"ReqType",
              SCRTAG_Screen,   (ULONG)Scr,
              SCRTAG_Flags,    WINFLGF_DepthGadget | WINFLGF_SimpleRefresh |
                               WINFLGF_SizeGadget | WINFLGF_Activate |
                               WINFLGF_CloseGadget | WINFLGF_Dragbar |
                               WINFLGF_SizeBBottom,
              SCRTAG_IDCMP,    IDCMP_CloseWindow | IDCMP_StdSysMsg,
              SCRTAG_AutoSizeGadget, (ULONG)VGrpGad,
              SCRTAG_ZipGadget,      TRUE,
              SCRTAG_IGfxType,       IGFXTYP_AppWin,
              SCRTAG_UnderMouse,     TRUE,
              TAG_DONE);

        if(Win) {
          struct pOS_IntuiMessage *Msg;
          BOOL Ende=FALSE;
          const UWORD MWidth =Win->win_Width;
          const UWORD MHeight=Win->win_Height;

          while(!Ende) {
            if(DOSSIGF_CTRL_C & pOS_WaitSignal((1<<Win->win_UserPort->mp_SigBit) | DOSSIGF_CTRL_C)) break;

            while(Msg=(struct pOS_IntuiMessage*)pOS_GetMsg(Win->win_UserPort)) {

              if(pOS_SysIMessage(Msg)) Msg=NULL;
              else {
                switch(Msg->im_Class) {

                  case IDCMP_GadgetUp:
                    if(    (struct pOS_Gadget*)Msg->im_IAddress == TestGad
                        || (struct pOS_Gadget*)Msg->im_IAddress == LVGad)
                    {
                      const CHAR* BodyStr;
                      const CHAR* ButtStr;
                      ULONG ID;

                      pOS_GetGadgetAttr(Win,LVGad,LVGADTAG_ItemID,&ID);
                      pOS_GetGadgetAttr(Win,BodyStrGad,STRGADTAG_String,(ULONG*)&BodyStr);
                      pOS_GetGadgetAttr(Win,ButtStrGad,STRGADTAG_String,(ULONG*)&ButtStr);

                      OpenReq(ID,gb_LVArray[ID].gti_Name,BodyStr,ButtStr,Win);
                    }
                    break;


                  case IDCMP_GadgetDown:
                  case IDCMP_UpdateGadget:
                    if( (struct pOS_Gadget*)Msg->im_IAddress == SlideGad) {
                      if(Msg->im_Code==IEGUCODE_Scroll) {
                        ULONG Idx;
                        pOS_GetGadgetAttr(Win,SlideGad,PRGADTAG_Top,&Idx);
                          pOS_SetGadgetAttrs(Win,LVGad,
                             LVGADTAG_ItemID,   Idx,
                             LVGADTAG_ViewItem, 0,    // aktuellen Item ins Sichtfeld
                             TAG_END);
                      }
                    }
                    else if( (struct pOS_Gadget*)Msg->im_IAddress == LVGad) {
                      if(Msg->im_Code==IEGUCODE_Select || Msg->im_Code==IEGUCODE_UpSelect) {
                        struct pOS_TagItem Tags[2];

                        Tags[0].ti_Tag=PRGADTAG_Top;
                        Tags[1].ti_Tag=TAG_END;
                        pOS_GetGadgetAttr(Win,LVGad,LVGADTAG_ItemID,&Tags[0].ti_Data);
                        pOS_SetGadgetAttrsA(Win,SlideGad,Tags);
                      }
                    }
                    break;

                  case IDCMP_CloseWindow:  Ende=TRUE; break;
                }
              }
              if(Msg) pOS_ReplyMsg(&Msg->im_Message);
            }
          }
          pOS_CloseWindow(Win);
        }
        else printf("Cannot open window\n");
      }
      else printf("Cannot create gadgets\n");
      pOS_UnlockPubScreen(Scr);
    }
    else printf("Cannot lock PubScreen\n");

    pOS_DeleteDosArgs(Args);  /* Args freigeben */
  }
  else Err=DOSFAIL_FAIL;  /* vollkommen fehlgeschlagen */

  pOS_SetShellFail(Err);

  pOS_CloseLibrary((pOS_Library*)gb_IntuiBase);
}
